package edu.bu.signstream.common.codingSchema;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import edu.bu.signstream.common.util.vo.CodingSchemaField;
import edu.bu.signstream.common.util.vo.CodingSchemaValue;
import edu.bu.signstream.common.util.vo.Constants;

public class CodingSchema {
	private HashMap codingSchema = new HashMap();

	private CodingSchemaField domGlossFld;
	private CodingSchemaField nonDomGlossFld;
	private CodingSchemaField domPosFld;
	private CodingSchemaField nonDomPosFld;

	private HashMap csFieldTypes = new HashMap();

	public static String NEW_FIELD_ID = "NEW FIELS ID";
	public static String NEW_VALUE_ID = "NEW VALUE ID";
	/*
		public CodingSchema(HashMap codingSchema) {
			this.codingSchema = codingSchema;
		}
	*/
	public CodingSchema() {
	}

	public HashMap getFieldTypes() {
		return csFieldTypes;
	}

	public void setFieldTypes(HashMap csFieldTypes) {
		this.csFieldTypes = csFieldTypes;
	}

	public HashMap getHandShapesImages() {		
//		
//		CodingSchemaFieldType fieldType =
//			(CodingSchemaFieldType) csFieldTypes.get(Constants.TYPE_HAND_SHAPE);
//		HashMap images = fieldType.getHandShapeImages();
//		
//		return images;
		
		return  null;
	}

	public void loadCodingSchema(HashMap codingSchema) {
		this.codingSchema = codingSchema;
	}

	public String getFieldID(String fieldName)
		throws IllegalArgumentException {
		Set keySet = codingSchema.keySet();
		Iterator it = keySet.iterator();

		while (it.hasNext()) {
			String fieldID = (String) it.next();
			CodingSchemaField field =
				(CodingSchemaField) codingSchema.get(fieldID);

			if (field.getName().endsWith(fieldName))
				return "" + field.getFieldId();
		}
		throw new IllegalArgumentException();
	}

	public HashMap getCodingSchema() {
		return codingSchema;
	}

	public int codingSchemaSize() {
		return codingSchema.size();
	}

	public void saveCodingSchemaField(CodingSchemaField field) {
		codingSchema.put("" + field.getFieldId(), field);
	}

	public ArrayList getCodingSchemaValues(String fieldID) {
		CodingSchemaField csField =
			(CodingSchemaField) codingSchema.get(fieldID);

		return csField.getCodingSchemeValues();
	}

	// ------------------------------------------------------- //	
	public CodingSchemaField getDomGlossFld() {
		return domGlossFld;
	}

	public void setDomGlossFld(CodingSchemaField domGlossFld) {
		this.domGlossFld = domGlossFld;
	}

	public CodingSchemaField getNonDomGlossFld() {
		return nonDomGlossFld;
	}

	public void setNonDomGlossFld(CodingSchemaField nonDomGlossFld) {
		this.nonDomGlossFld = nonDomGlossFld;
	}

	public CodingSchemaField getDomPosFld() {
		return domPosFld;
	}

	public void setDomPosFld(CodingSchemaField domPosFld) {
		this.domPosFld = domPosFld;
	}

	public CodingSchemaField getNonDomPosFld() {
		return nonDomPosFld;
	}

	public void setNonDomPosFld(CodingSchemaField nonDomPosFld) {
		this.nonDomPosFld = nonDomPosFld;
	}
	// -------------------------------------------------------- //	

	public CodingSchemaField getCodingSchemaField(String fieldID) {
		if (fieldID == CodingSchema.NEW_FIELD_ID)
			return createCodingSchemaField();

		//
		CodingSchemaField csField =
			(CodingSchemaField) codingSchema.get(fieldID);

		//System.err.println("CodingSchemaField csField = " + csField);
		//
		return csField; //(CodingSchemaField) codingSchema.get(fieldID);
	}

	public CodingSchemaField createCodingSchemaField() {
		CodingSchemaField field = new CodingSchemaField();
		field.setFieldId(createFieldID());

		ArrayList list = new ArrayList();
		field.setCodingSchemeValues(list);

		return field;
	}

	private int createFieldID() {
		int i = 0;

		while (true) {
			if (!codingSchema.containsKey("" + i))
				return i;
			i++;
		}
	}

	public void addCodingSchemaValue(String fieldID, CodingSchemaValue value) {
		CodingSchemaField csField =
			(CodingSchemaField) codingSchema.get(fieldID);
		csField.addCodingSchemeValues(value);
	}

	public ArrayList getExistingValueIDs(String fieldID) {
		ArrayList list = new ArrayList();
		CodingSchemaField csField =
			(CodingSchemaField) codingSchema.get(fieldID);

		ArrayList values = csField.getCodingSchemeValues();

		for (int i = 0; i < values.size(); i++) {
			CodingSchemaValue value = (CodingSchemaValue) values.get(i);
			list.add("" + value.getValueId());
		}

		return list;
	}

	public boolean isValueIDExist(String valueID, String fieldID) {
		ArrayList fieldIDs = getExistingValueIDs(fieldID);

		for (int i = 0; i < fieldIDs.size(); i++) {
			String id = (String) fieldIDs.get(i);
			if (id.equals(valueID))
				return true;
		}

		return false;
	}

	public String getNextAvailableValueID(String fieldID) {
		int i = 0;

		while (true) {
			if (!isValueIDExist("" + i, fieldID))
				return "" + i;
			i++;
		}
	}

	public boolean isTextEntryField(String trackId) {
		ArrayList textEntryIdList = Constants.getTestEntryIdList();

		for (int i = 0; i < textEntryIdList.size(); i++) {
			String id = (String) textEntryIdList.get(i);
			if (trackId.equals(id)) {
				return true;
			}
		}
		return false;
	}
}
