package edu.bu.signstream.common.db;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FilePermission;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardCopyOption;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class XMLWriter {

	public static Document createNewXMLDocument(String path) throws Exception {
		Document document = null;
		// try {
		DocumentBuilderFactory domFactory = DocumentBuilderFactory
				.newInstance();
		DocumentBuilder domBuilder = domFactory.newDocumentBuilder();
		document = domBuilder.newDocument();
		// } catch (Exception ex) {
		// SS3SignStreamApplication.logger.log(Level.INFO, ex.getMessage());
		// }
		return document;
	}
	
	public static boolean saveAnnotatorsDocument(Element root, String fileName)
	{
		// annotator-file-specific logic
		//then call saveDocument(file) - file to be created here and destroyed after callee returns
		return false;
	}
	
	public static boolean savePariticpantsDocument(Element root, String fileName)
	{
		return false;
	}
	
	public static boolean saveDocument(Element root, String fileName)
			throws Exception {

		File file = new File(fileName);

		if (!file.exists()) {
			boolean created = file.createNewFile();
			if (!created) {
				return false;
			}
		}

		FilePermission permission = new FilePermission(fileName, "read,write");
		OutputStream outputStream = new FileOutputStream(file);
		TransformerFactory tFactory = TransformerFactory.newInstance();
		Transformer transformer = tFactory.newTransformer();

		String separator = System.getProperty("line.separator");
		String newSeparator = "\n";
		System.setProperty("line.separator", newSeparator);
		// format output
		transformer.setOutputProperty(OutputKeys.INDENT, "yes");

		DOMSource source = new DOMSource(root);
		StreamResult result = new StreamResult(outputStream);

		transformer.transform(source, result);

		System.setProperty("line.separator", separator);

		outputStream.flush();
		outputStream.close();
		transformer = null;

		// below is needed to get rid of blank lines which enter the file for some inexplicable reason...
		var str = file.getAbsoluteFile().getAbsolutePath() + ".out";
		File copy = new File(str);
		copy.getAbsoluteFile().getParentFile().mkdir();
		copy.createNewFile();
		
		FileReader fr = new FileReader(file); 
		BufferedReader br = new BufferedReader(fr); 
		FileWriter fw = new FileWriter(copy); 
		String line;

		while((line = br.readLine()) != null)
		{ 
			var trimmedLine = line.trim();
			if (!trimmedLine.equals("")) // don't write out completely blank lines
			{
				fw.write(line, 0, line.length());
				fw.write(System.getProperty("line.separator"));
			}
		} 
		fr.close();
		fw.close();

		Path p1 = Paths.get(copy.getAbsolutePath());
		Path p2 = Paths.get(file.getAbsolutePath());
		Files.move(p1, p2, StandardCopyOption.REPLACE_EXISTING);

		return true;
	}
}
