package edu.bu.signstream.common.graph;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.time.TimeRange;

import java.net.URI;

public class Graph {
    private final String id;
    private final String name;
    private final URI uri;
    private TimeRange range;

    public Graph(String id, String name, URI uri, TimeRange range) {
        this.id = id;
        this.name = name;
        this.uri = uri;
        this.range = range;
    }
    public Graph(String name, URI uri, TimeRange range) {
        this(Util.uuid(), name, uri, range);
    }

    public String id() { return id; }
    public String name() { return name; }
    public URI uri() { return uri; }
    public TimeRange range() { return range; }

    public void range(TimeRange range) { this.range = range; }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof Graph && id.equals(((Graph)obj).id);
    }
}
