package edu.bu.signstream.common.util.vo;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.ui.SS3SignStreamApplication;
import edu.bu.signstream.ui.panels.search.SearchDialog;

import java.util.*;

public class Constants {
	public static final int LEGACY_HOLD_CODE = 400000;
	public static final int LEGACY_ONSET_CODE = 400001;
	public static final int LEGACY_OFFSET_CODE = 400002;
	public static final int LEGACY_EMPTY_CODE = 400003;

	public static final int NONMANUAL_ONSET_CODE = 500000;
	public static final int NONMANUAL_INITIAL_HOLD_CODE = 500001;
	public static final int NONMANUAL_FINAL_HOLD_CODE = 500002;
	public static final int NONMANUAL_OFFSET_CODE = 500003;
	public static final int NONMANUAL_EMPTY_CODE = 500004;

	public static final int GLOSS_ONSET_CODE = 600000;
	public static final int GLOSS_INITIAL_HOLD_CODE = 600001;
	public static final int GLOSS_FINAL_HOLD_CODE = 600002;
	public static final int GLOSS_OFFSET_CODE = 600003;
	public static final int GLOSS_EMPTY_CODE = 600004;

	public static final int GESTURE_PREPARATION_CODE = 700000;
	public static final int GESTURE_PRESTROKE_HOLD_CODE = 700001;
	public static final int GESTURE_POSTSTROKE_HOLD_CODE = 700002;
	public static final int GESTURE_RETRACTION_CODE = 700003;
	public static final int GESTURE_RELAXED_CODE=  700004;
	public static final int GESTURE_EMPTY_CODE = 700005;

	public static final int APEX_ONSET_CODE = 800000;
	public static final int APEX_INITIAL_HOLD_CODE = 800001;
	public static final int APEX_FINAL_HOLD_CODE = 800002;
	public static final int APEX_OFFSET_CODE = 800003;
	public static final int APEX_EMPTY_CODE = 800004;

	public static final String INCONSISTENT_XML_ERROR_CODE = "1000";
	
	public static final ArrayList<Integer> PHASES_CODES = new ArrayList<Integer>(Arrays.asList(
			LEGACY_HOLD_CODE, LEGACY_ONSET_CODE, LEGACY_OFFSET_CODE, LEGACY_EMPTY_CODE,
			
			NONMANUAL_ONSET_CODE, NONMANUAL_INITIAL_HOLD_CODE, NONMANUAL_FINAL_HOLD_CODE,
			NONMANUAL_OFFSET_CODE, NONMANUAL_EMPTY_CODE,
			
			GLOSS_ONSET_CODE, GLOSS_INITIAL_HOLD_CODE, GLOSS_FINAL_HOLD_CODE, 
			GLOSS_OFFSET_CODE, GLOSS_EMPTY_CODE,
			
			GESTURE_PREPARATION_CODE, GESTURE_PRESTROKE_HOLD_CODE, GESTURE_POSTSTROKE_HOLD_CODE,
			GESTURE_RETRACTION_CODE, GESTURE_RELAXED_CODE, GESTURE_EMPTY_CODE,
			
			APEX_ONSET_CODE, APEX_INITIAL_HOLD_CODE, APEX_FINAL_HOLD_CODE,
			APEX_OFFSET_CODE, APEX_EMPTY_CODE
		));

	// the below are only used in SS2->SS3 logic -- ignoring
	public static final String HOLD_VAL = "HOLD";
	public static final String ONSET_VAL = "ONSET";
	public static final String OFFSET_VAL = "OFFSET";
	public static final String EMPTY_VAL = "EMPTY";

	public static final String ONSET = "Onset";
	public static final String PREPARATION = "Preparation";
	
	public static final String INITIAL_HOLD = "Initial Hold";
	public static final String PRESTROKE_HOLD = "Pre-Stroke Hold";
	
	public static final String OFFSET = "Offset";
	public static final String RETRACTION = "Retraction";
	
	public static final String FINAL_HOLD = "Final Hold";
	public static final String POSTSTROKE_HOLD = "Post-Stroke Hold";
	
	public static final String VALUE = "Value";
	
	public static final String RELAXED = "Relaxed";
	
	public static final String TEXT_VALUE = "Text Value";

	public static final String NONMANUAL_PANEL_ID = "0";
    public static final String DEFAULT_PANEL_ID = "1";
    public static final String SIGN_PANEL_ID = "2";
    public static final String GESTURE_PANEL_ID = "3";

	public static HashMap<String, Integer> panelOrders = new HashMap<>();
	static {
		panelOrders.put(NONMANUAL_PANEL_ID, 0);
		panelOrders.put(DEFAULT_PANEL_ID, 1);
		panelOrders.put(SIGN_PANEL_ID, 2);
		panelOrders.put(GESTURE_PANEL_ID, 3);
	}

	@Deprecated
	public static ArrayList<String> getReservedCodingSchemaCodes() {
		ArrayList<String> list = new ArrayList<String>();
		list.add("" + Constants.LEGACY_HOLD_CODE);
		list.add("" + Constants.LEGACY_ONSET_CODE);
		list.add("" + Constants.LEGACY_OFFSET_CODE);
		list.add("" + Constants.LEGACY_EMPTY_CODE);
		return list;
	}

	private static ArrayList<String> textEntryIdList = null;

	public static ArrayList<String> getTestEntryIdList() {
		if (textEntryIdList == null) {
			textEntryIdList = new ArrayList<String>();
			textEntryIdList.add("31");
			textEntryIdList.add("42");
			textEntryIdList.add(Util.DOM_GLOSS_FIELD_ID);
			textEntryIdList.add(Util.NDOM_GLOSS_FIELD_ID);
			textEntryIdList.add("20000");
			textEntryIdList.add("20001");
		}
		return textEntryIdList;
	}

	public static final String SIGNATURE = "sASL";
	public static final int RECENT_FILE_VERSION = 31;
	public static final int CURRENT_FILE_VERSION = 32;

	// see "asl utterance scrap.h"
	public static final int UTT_CURR_SCRAP_FORMAT_VERSION = 14;

	// see "asl MD scrap.h"
	public static final int MD_CURR_SCRAP_FORMAT_VERSION = 1;

	// see "asl MediaRef scrap.h"
	public static final int MREF_CURR_SCRAP_FORMAT_VERSION = 1;

	// see "asl field scrap.h":
	public static final int FIELD_CURR_SCRAP_FORMAT_VERSION = 5;

	// see "asl non-manual data scrap.h":
	public static final int NON_MANUAL_DATA_CURR_SCRAP_FORMAT_VERSION = 4;

	// see "asl gloss data scrap.h":
	public static final int GLOSS_CURR_SCRAP_FORMAT_VERSION = 3;

	public static final String TYPE_NON_MANUAL_OLD = "0";
	public static final String TYPE_GLOSS_OLD = "1";
	public static final String TYPE_POS_TAG_OLD = "2"; // unused in SS2
	public static final String TYPE_FREE_TEXT_OLD = "3";
	public static final String TYPE_HAND_SHAPE_OLD = "4";

	public static final String TYPE_NON_MANUAL = "NMN";
	public static final String TYPE_NON_MANUAL_FREE_TEXT = "NMNFRT";

	public static final String TYPE_GLOSS = "GLS";

	public static final String TYPE_GLOSS_LEGACY = "LGGLS";
	public static final String TYPE_DOM_GLOSS = "DGLS";
	public static final String TYPE_NDOM_GLOSS = "NGLS";
	public static final String TYPE_DOM_POS_TAG = "DPOS"; // unused in SS2
	public static final String TYPE_NDOM_POS_TAG = "NPOS"; // unused in SS2
	public static final String TYPE_DOM_HAND_SHAPE = "DHSH"; // unused in SS2
	public static final String TYPE_NDOM_HAND_SHAPE = "NHSH"; // unused in SS2
	public static final String TYPE_DOM_TEXT = "DTXT";
	public static final String TYPE_NDOM_TEXT = "NTXT";

	public static final String TYPE_DOM_LOCATION = "DLOC";
	public static final String TYPE_NDOM_LOCATION = "NLOC";
	
	public static final String TYPE_DOM_SIGN_TYPE = "DSGN";
	public static final String TYPE_NDOM_SIGN_TYPE = "NSGN";
	
	public static final String TYPE_DOM_GESTURE = "DGES";
	public static final String TYPE_NDOM_GESTURE = "NGES";
	public static final String TYPE_DOM_GESTURE_APEX = "DAPX";
	public static final String TYPE_NDOM_GESTURE_APEX = "NAPX";
	public static final String TYPE_DOM_GESTURE_HAND = "DGHD";
	public static final String TYPE_NDOM_GESTURE_HAND = "NGHD";
	public static final String TYPE_DOM_GESTURE_HANDSHAPE = "DGHS";
	public static final String TYPE_NDOM_GESTURE_HANDSHAPE = "NGHS";
	public static final String TYPE_DOM_GESTURE_FINGER_TIP_ORIENTATION = "DFTORN";
	public static final String TYPE_NDOM_GESTURE_FINGER_TIP_ORIENTATION = "NFTORN";
	public static final String TYPE_DOM_GESTURE_PROPERTY = "DGPT";
	public static final String TYPE_NDOM_GESTURE_PROPERTY = "NGPT";
	public static final String TYPE_DOM_GESTURE_CATEGORY = "DGCAT";
	public static final String TYPE_NDOM_GESTURE_CATEGORY = "NGCAT";
	public static final String TYPE_DOM_GESTURE_LOCATION = "DGLOC";	
	public static final String TYPE_NDOM_GESTURE_LOCATION = "NGLOC";	
	public static final String TYPE_GESTURE_FREE_TEXT = "GFRT";		// TODO: this should be removed
	public static final String TYPE_DOM_GESTURE_PALM_ORIENTATION = "DHPO";
	public static final String TYPE_NDOM_GESTURE_PALM_ORIENTATION = "NHPO";


	public static final String TYPE_DOM_HAND_LOCATION = "DHSL";
	public static final String TYPE_NDOM_HAND_LOCATION = "NHSL";
	public static final String TYPE_DOM_HAND_MOVEMENT = "DHSM";
	public static final String TYPE_NDOM_HAND_MOVEMENT = "NHSM";
	public static final String TYPE_DOM_HAND_ORIENTATION = "DHSFTO";
	public static final String TYPE_NDOM_HAND_ORIENTATION = "NHSFTO";
	public static final String TYPE_DOM_HAND_SEL_FINGERS = "DHSSF";
	public static final String TYPE_NDOM_HAND_SEL_FINGERS = "NHSSF";
	public static final String TYPE_DOM_HAND_BASE_JOINTS = "DHSBJ";
	public static final String TYPE_NDOM_HAND_BASE_JOINTS = "NHSBJ";
	public static final String TYPE_DOM_HAND_SPREAD = "DHSSP";
	public static final String TYPE_NDOM_HAND_SPREAD = "NHSSP";
	public static final String TYPE_DOM_HAND_NON_BASE_JOINTS = "DHSNJ";
	public static final String TYPE_NDOM_HAND_NON_BASE_JOINTS = "NHSNJ";
	public static final String TYPE_DOM_HAND_NON_SEL_FINGERS = "DHSNF";
	public static final String TYPE_NDOM_HAND_NON_SEL_FINGERS = "NHSNF";
	public static final String TYPE_DOM_HAND_THUMB_CONTACT = "DHSTC";
	public static final String TYPE_NDOM_HAND_THUMB_CONTACT = "NHSTC";

	public static final String TYPE_HAND = "HND";
	public static final String TYPE_DOM_HAND = "DHND";
	public static final String TYPE_NDOM_HAND = "NHND";

	public static final String TYPE_FREE_TEXT = "FRT";
	
	public static final String TYPE_CUSTOM_INTERVAL = "CSTI";
	public static final String TYPE_CUSTOM_POINT = "CSTP";
	public static final String TYPE_CUSTOM_SECTION = "CSTS";

	public static final ArrayList<String> EDITABLE_TYPE_VALUES =  new ArrayList<String>(Arrays.asList(
			TYPE_NON_MANUAL, TYPE_NON_MANUAL_FREE_TEXT,
			TYPE_CUSTOM_INTERVAL, TYPE_CUSTOM_POINT, TYPE_CUSTOM_SECTION
			));
	
	public static final int HEAD_GROUP_ID = 0;
	public static final String HEAD_GROUP_NAME = "Head";
	public static final String HEAD_GROUP_NAME_CAPS = "HEAD";
	public static final int FACE_GROUP_ID = 1;
	public static final String FACE_GROUP_NAME = "Face";
	public static final String FACE_GROUP_NAME_CAPS = "FACE";
	public static final int BODY_GROUP_ID = 2;
	public static final String BODY_GROUP_NAME = "Body";
	public static final String BODY_GROUP_NAME_CAPS = "BODY";
	public static final int GRAMMATICAL_GROUP_ID = 3;
	public static final String GRAMMATICAL_GROUP_NAME = "Grammatical";
	public static final String GRAMMATICAL_GROUP_NAME_CAPS = "GRAMMATICAL";
	
	public static final int SPEECH_GROUP_ID = 0;
	public static final String SPEECH_GROUP_NAME = "Speech";
	public static final String SPEECH_GROUP_NAME_CAPS = "SPEECH";
	public static final int GENERIC_GROUP_ID = 1;
	public static final String GENERIC_GROUP_NAME = "Generic";
	public static final String GENERIC_GROUP_NAME_CAPS = "GENERIC";
	
	public static final int MANUAL_GROUP_ID = 0;
	public static final String MANUAL_GROUP_NAME = "Manual";
	public static final String MANUAL_GROUP_NAME_CAPS = "MANUAL";
	
	public static final int GESTURE_GROUP_ID = 0;
	public static final String GESTURE_GROUP_NAME = "Gesture";
	public static final String GESTURE_GROUP_NAME_CAPS = "GESTURE";
	public static final int GESTURE_DOM_CATEGORY_GROUP_ID = 1;
	public static final String GESTURE_DOM_CATEGORY_GROUP_NAME = "Dom Gesture Categories";
	public static final String GESTURE_DOM_CATEGORY_GROUP_NAME_CAPS = "DOM_GESTURE_CATEGORY";
	public static final int GESTURE_NDOM_CATEGORY_GROUP_ID = 2;
	public static final String GESTURE_NDOM_CATEGORY_GROUP_NAME = "Ndom Gesture Categories";
	public static final String GESTURE_NDOM_CATEGORY_GROUP_NAME_CAPS = "NDOM_GESTURE_CATEGORY";

	public static final String TYPE_GRAPH = "GPH";

	public static final String DOMINANT = "dom";
	public static final String NON_DOMINANT = "ndom";

	public static final String VC_BODY_LOCATION = "1";
	public static final String VC_PROXIMITY = "2";
	public static final String VC_LATERALIZATION = "3";
	public static final String VC_DIRECTIONAL_MOVEMENT = "4";
	public static final String VC_MOVEMENT_CONTOUR = "5";
	public static final String VC_REPETITION = "6";
	public static final String VC_COORDINATION = "7";
	public static final String VC_MANER_OF_TOUCH = "8";

	public static final int DAI_SEARCH_MAXIMUM_ALLOWED_VIDEO_TIME = 7;
	public static final int DEFAULT_DAI_SUCCESS_CODE = 0;
	public static final int DEFAULT_DAI_NO_CHOICE_SELECTION_CODE = 1;

	public static final int MIN_DAI_LOADING_TIME = 3000;

	public static final String DisplayTimeViewWrapper = "DisplayTimeViewWrapper";
	public static final String PresentationFieldWrapper = "PresentationFieldWrapper";
	public static final String SegmentFieldWrapper = "SegmentFieldWrapper";

	public static final String GESTURE_ORIENTATION_FINGER_TIP_ORIENTATION_TILE = "Finger Tip Orientation";
	public static final String GESTURE_ORIENTATION_PALM_ORIENTATION_TITLE = "Palm Orientation";

	
	public static final ArrayList<String> VALID_GROUP_VALUES = new ArrayList<String>(Arrays.asList(
			HEAD_GROUP_NAME_CAPS, FACE_GROUP_NAME_CAPS,
			BODY_GROUP_NAME_CAPS, GRAMMATICAL_GROUP_NAME_CAPS
			));

	// --------------------- //

	public static final int GROUP_UPPER = 0;
	public static final int GROUP_FIXED = 1;
	public static final int GROUP_LOWER = 2;

	// ID offsets, since each group starts fields at zero in DB files
	public static final int GROUP_FIXED_ID_OFFSET = 10000;
	public static final int GROUP_LOWER_ID_OFFSET = 20000;

	public static final List<Class> importantDialogs = Arrays.<Class>asList(
			SS3SignStreamApplication.class,
			SearchDialog.class
	);

	public static final Set<String> staticNonManualFields = Collections.emptySet();
    public static final Set<String> staticGlossFields = Set.of(
        Util.DOM_GLOSS_FIELD_ID, Util.NDOM_GLOSS_FIELD_ID,
        Util.DOM_HAND_FIELD_ID, Util.NDOM_HAND_FIELD_ID,
        Util.DOM_HANDSHAPE_FIELD_ID, Util.NDOM_HANDSHAPE_FIELD_ID,
        Util.FREE_TEXT_FIELD_ID
    );
    public static final Set<String> staticCustomFields = Collections.emptySet();
    public static final Set<String> staticGestureFields = Set.of(
        Util.DOM_GESTURE_FIELD_ID, Util.NDOM_GESTURE_FIELD_ID,
        Util.DOM_GESTURE_HAND_FIELD_ID, Util.NDOM_GESTURE_HAND_FIELD_ID,
        Util.DOM_GESTURE_HANDSHAPE_FIELD_ID, Util.NDOM_GESTURE_HANDSHAPE_FIELD_ID,
        Util.DOM_GESTURE_ORIENTATION_FINGER_TIP_FIELD_ID, Util.NDOM_GESTURE_ORIENTATION_FINGER_TIP_FIELD_ID, Util.DOM_GESTURE_PALM_FIELD_ID,
		Util.NDOM_GESTURE_PALM_FIELD_ID/*, Util.DOM_GESTURE_FINGERS_FIELD_ID, Util.NDOM_GESTURE_FINGERS_FIELD_ID,*/
    );

    public static boolean isStaticField(String fieldId) {
        return staticNonManualFields.contains(fieldId)
            || staticGlossFields.contains(fieldId)
            || staticCustomFields.contains(fieldId)
            || staticGestureFields.contains(fieldId);
    }
}
