package edu.bu.signstream.common.util.vo;

import java.util.*;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.common.util.Sorter;

public class Segment {
  private String participantId;
  private boolean primaryParticipant = false;
  private HashMap<String, Track> tracks = new HashMap<String, Track>();
   
  
  public Segment() {
  }
  
  public Segment(String participantId, String primaryParticipant, HashMap<String, Track> tracks) {
  	this.participantId = participantId;
  	this.primaryParticipant = Util.str2Bool(primaryParticipant);
  	this.tracks = tracks;
  }
  
  public Segment(String participantId, boolean primaryParticipant, HashMap<String, Track> tracks) {
     this.participantId = participantId;
     this.primaryParticipant = primaryParticipant;
     this.tracks = tracks;
    }
  
  @Override
public String toString() {
    StringBuffer sb = new StringBuffer();
    sb.append("Segment:");
    sb.append("\n participantId = ");
    sb.append(participantId);
    sb.append("\n primaryParticipant = ");
    sb.append(primaryParticipant);   
    sb.append("\n number of tracks = ");
    sb.append(tracks.size());
    sb.append("\n tracks = ");

    return sb.toString();
  }
	
  public String getParticipantId() {
	return participantId;
  }

  public void setParticipantId(String participantId) {
	this.participantId = participantId;
  }

  public boolean isPrimaryParticipant() {
	return primaryParticipant;
  }

  public void setPrimaryParticipant(boolean primaryParticipant) {
	this.primaryParticipant = primaryParticipant;
  }

  public HashMap<String, Track> getTracks() {
	return tracks;
  }
  
  public ArrayList<String> getSortedTrackIDList() {
  	ArrayList<String> list = new ArrayList<String>();
  	Set<String> set = tracks.keySet(); //entrySet();
	Object[] obj = Sorter.sortIntegerSet(set);
	
	for(int i = 0; i < obj.length; i ++) {
		list.add((String)obj[i]);
	}
	return list;
  }

  public void setTracks(HashMap<String, Track> tracks) {
	this.tracks = tracks;
  }
}
