package edu.bu.signstream.common.util.vo.ss3;

import javax.swing.*;
import java.awt.event.*;
//import java.awt.*;
//import java.fields.*;
//import javax.swing.*;
import edu.bu.signstream.grepresentation.requestsHandler.Manager;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.*;
//import edu.bu.signstream.grepresentation.view.*;
//import edu.bu.signstream.common.fields.vo.ss3.db.*;
//import edu.bu.signstream.grepresentation.fields.presentation.*;
import edu.bu.signstream.grepresentation.fields.dictionary.*;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class SegmentToolBar extends JToolBar implements ActionListener {

   private final SignStreamSegmentPanel segmentPanel;

   private final JButton backBtn = new JButton("Back");
   private final JToggleButton itemBtn = new JToggleButton(" Item ");
   private final JToggleButton entityBtn = new JToggleButton("Entity");
   private final JToggleButton utrBtn = new JToggleButton("Utterance");

   private final JButton deleteBtn = new JButton("Delete");
   private final JButton dictionaryBtn = new JButton("Dictionary");
   private final JButton saveBtn = new JButton("SAVE");

   private final JButton mediaBtn = new JButton("Media");

   private final int BACK = 0;
   private final int ITEM = 1;
   private final int ENTITY = 2;
   private final int UTTERANCE = 3;
   private final int DELETE = 4;
   private final int DICTIONARY = 5;
   private final int SAVE = 6;
   private final int MEDIA = 7;

   public boolean isItemSelected() {
      return itemBtn.isSelected();
   }

   public boolean isEntitySelected() {
      return entityBtn.isSelected();
   }

   public boolean isUtteranseSelected() {
      return utrBtn.isSelected();
   }

   public SegmentToolBar(SignStreamSegmentPanel panel) {
      super("Segment Tool Bar");
      this.segmentPanel = panel;
      setBorderPainted(true);

      itemBtn.setSelected(true);

      backBtn.setActionCommand("" + BACK);
      itemBtn.setActionCommand("" + ITEM);
      entityBtn.setActionCommand("" + ENTITY);
      utrBtn.setActionCommand("" + UTTERANCE);
      deleteBtn.setActionCommand("" + DELETE);
      dictionaryBtn.setActionCommand("" + DICTIONARY);
      saveBtn.setActionCommand("" + SAVE);
      mediaBtn.setActionCommand("" + MEDIA);

      backBtn.addActionListener(this);
      //itemBtn.addActionListener(this);
      //entityBtn.addActionListener(this);
      deleteBtn.addActionListener(this);
      dictionaryBtn.addActionListener(this);
      saveBtn.addActionListener(this);
      mediaBtn.addActionListener(this);

      itemBtn.addItemListener(new ItemListener() {
         @Override
		public void itemStateChanged(ItemEvent e) {
            int state = e.getStateChange();
            if (state == ItemEvent.SELECTED) {
               entityBtn.setSelected(false);
               utrBtn.setSelected(false);

               Segment segment = segmentPanel.getSegments().get(0);
               FieldWrappersCollection col =
                  segment.getFieldWrappersCollection();
               EventsEntity entity = col.getSelectedEntity();
               if (entity != null)
                  entity.selectEventIfEntitySelected();

               segmentPanel.repaint();
            }
         }
      });

      entityBtn.addItemListener(new ItemListener() {
         @Override
		public void itemStateChanged(ItemEvent e) {
            int state = e.getStateChange();
            if (state == ItemEvent.SELECTED) {
               itemBtn.setSelected(false);
               utrBtn.setSelected(false);

               Segment segment = segmentPanel.getSegments().get(0);
               FieldWrappersCollection col =
                  segment.getFieldWrappersCollection();
               col.selectEntityIfItemSelected();

               segmentPanel.repaint();
            }
         }
      });

      utrBtn.addItemListener(new ItemListener() {
         @Override
		public void itemStateChanged(ItemEvent e) {
            int state = e.getStateChange();
            if (state == ItemEvent.SELECTED) {
               itemBtn.setSelected(false);
               utrBtn.setSelected(false);

               //					Manager mngr = SS3Singleton.getManager();
               //					Segment segment = mngr.getLoadedSegment();
               Segment segment = segmentPanel.getSegments().get(0);
               FieldWrappersCollection col =
                  segment.getFieldWrappersCollection();

               if (col.getSelectedEntity() != null)
                  col.getSelectedEntity().unselect();

               if (col.getSelectedEvent() != null)
                  col.getSelectedEvent().unselect();

//               QTMultiMovieController cntr =
//                  segmentPanel.getQTMultiMovieController();
//
//               int startTime = segment.getStartTime();
//               int endTime = segment.getEndTime();
//               cntr.unselectSegment();
//               cntr.selectSegment(startTime, endTime);

               //mngr.getSegmentPanel()
               segmentPanel.repaint();
            }
         }
      });
      add(backBtn);
      add(itemBtn);
      add(entityBtn);
      add(utrBtn);
      add(deleteBtn);
      add(dictionaryBtn);
      add(saveBtn);
      add(mediaBtn);
   }

   @Override
public void actionPerformed(ActionEvent ae) {
      String str = ae.getActionCommand();
      Manager mngr = SS3Singleton.getManager();
      switch (Integer.parseInt(str)) {
         case BACK :
        		segmentPanel.loadDatabase(null); //.loadUtterance(ArrayList<Segment> segments); //reload(new ArrayList<Segment>(), SignStreamSegmentPanel.GLOSS_WINDOW);
            break;
         case DELETE :
            // delete selected event (item or entity)
            break;
         case DICTIONARY :
            DictionaryDialog d = new DictionaryDialog();
            d.show();
            d.setVisible(true);
            break;
         case SAVE :
            // save all changes to the disc
            break;
         case MEDIA :
//            MediaDialog md = new MediaDialog(segmentPanel.getParentFrame(), segmentPanel);

//            if (segmentPanel.getParentDialog() != null) {
//               md =
//                  new MediaDialog(segmentPanel.getParentDialog(), segmentPanel);
//            } else {
//               md =
//                  new MediaDialog(segmentPanel.getParentFrame(), segmentPanel);
            //}
            
//            md.show();
//            md.setVisible(true);
            break;
      }
   }
}
