package edu.bu.signstream.common.util.vo.ss3.codingScheme.gestureMenus;

import java.util.HashMap;

public class GestureCategory {

	private String id;
	private String name;
	private String parentCategoryId;
	private String order;
	
	private HashMap<String, GestureProperty> gestureProperties = new HashMap<String, GestureProperty>();
	
	public String getParentCategoryId() {
		return parentCategoryId;
	}
	
	public void setParentCategoryId(String parentCategoryId) {
		this.parentCategoryId = parentCategoryId;
	}
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public void setOrder(String order) {
		this.order = order;
	}

	public String getOrder() {
		return order;
	}
	
	public void addGestureProperty(GestureProperty property) {
		gestureProperties.put(property.getId(), property);
	}
	
	public HashMap<String, GestureProperty> getGestureProperties(){
		return gestureProperties;
	}
	
	/*public String getDomFieldID() {
		return this.domFieldID;
	}
	
	public void setDomFieldID(String domFieldID) {
		this.domFieldID = domFieldID;
	}
	
	public String getNdomFieldID() {
		return this.ndomFieldID;
	}
	
	public void setNDomFieldID(String ndomFieldID) {
		this.ndomFieldID = ndomFieldID;
	}
	*/
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!(obj instanceof GestureCategory)) {
			return false;
		}
		GestureCategory other = (GestureCategory) obj;
		if (id == null) {
			if (other.id != null) {
				return false;
			}
		} else if (!id.equals(other.id)) {
			return false;
		}
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		if (parentCategoryId == null) {
			if (other.parentCategoryId != null) {
				return false;
			}
		} else if (!parentCategoryId.equals(other.parentCategoryId)) {
			return false;
		}
		return true;
	}
	
	@Override
	public String toString() {
		return name;
		//int numChildren = this.children == null ? 0 : this.children.size();
		//return "ID: " + this.id + " NAME: " + this.name + " NUM CHILDREN: " + numChildren;
	}
}
