package edu.bu.signstream.common.util.vo.ss3.db;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * Class under development, along with SS3EntityEdit.
 *
 */
public class SS3EntityHistoryCollection {
	
	// String of entityID --> List<edits>
	private HashMap<String, ArrayList<SS3EntityEdit>> collection = new HashMap<String, ArrayList<SS3EntityEdit>>();

	public SS3EntityHistoryCollection(HashMap<String, ArrayList<SS3EntityEdit>> collection) {
		this.collection.clear();
		this.collection.putAll(collection);
	}
	
	public void addEntity(String entityID) {
		collection.put(entityID, new ArrayList<SS3EntityEdit>());
	}
	
	public void addEntityEdit(SS3EntityEdit entityEdit) {
		ArrayList<SS3EntityEdit> entityEditList = collection.get(entityEdit.getEntityID());
		entityEditList.add(entityEdit);
	}
	
	public ArrayList<SS3EntityEdit> getAllEditsByEntity(String entityID) {
		return collection.get(entityID) != null ? new ArrayList<SS3EntityEdit>(collection.get(entityID)) : null;
	}
	
	public void deleteEntity(String entityID) {
		collection.remove(entityID);
	}
	
	public int getSize() {
		return collection.size();
	}
	
	public int getSizeOfEntityHistory(String entityID) {
		return collection.get(entityID) != null ? collection.get(entityID).size() : -1;
	}
	
	@Override
	public String toString() {
		return null;		
	}
}
