package edu.bu.signstream.common.util.vo.ss3.note;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3Field;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.common.util.vo.ss3.participants.ParticipantsLibrary;
import edu.bu.signstream.common.util.vo.ss3.participants.SS3Participant;
import edu.bu.signstream.grepresentation.requestsHandler.Manager;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;

public class SS3CompleteNoteInformation {
   private SS3Note note;
   private String fieldID;

   private String fieldName;
   private String fieldType;

   private String entityID;
   private String itemInitialText;

   public void setFiledID(String fieldID) {
      SS3CodingScheme dbScheme =
         SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getSS3Database().getSS3CodingScheme();
      SS3Field csField = dbScheme.getField(fieldID);
      this.fieldID = fieldID;
      this.fieldName = csField.getName();
      this.fieldType = csField.getType();
   }

   public void setFieldName(String fieldName) {
      this.fieldName = fieldName;
   }

   public void setFieldType(String fieldType) {
      this.fieldType = fieldType;
   }

   public void setNote(SS3Note note) {      
      this.note = note; 
   }

   public void setNoteID(String noteID) {
      if (note != null)
         note.setID(noteID);
   }

   public void setValueID(String valueID) {
      SS3CodingScheme cs =
         SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getSS3Database().getSS3CodingScheme();

      SS3FieldValue csValue =
         cs.getField(fieldID) != null
            ? cs.getField(fieldID).getFieldValue(valueID)
            : null;
      if (csValue != null)
         itemInitialText = csValue.getName();
   }

   public void setEntityID(String entityID) {
      this.entityID = entityID;
   }

   public void setItemInitialText(String itemInitialText) {
      this.itemInitialText = itemInitialText;
   }

   public String getEntityID() {
      return entityID != null ? entityID : "";
   }

   public String getItemInitialText() {
      return itemInitialText != null ? itemInitialText : "";
   }

   public String getItemInitialTextShort() {
      if (itemInitialText == null)
         return "";
      if (itemInitialText.length() <= 10)
         return itemInitialText;

      return itemInitialText.substring(0, 10);
   }

   public String getNoteSubjectShort() {
      String subject = note.getSubject();
      if (subject == null)
         return "";
      if (subject.length() <= 10)
         return subject;

      return subject.substring(0, 10);
   }

   public String getFieldNameShort() {
      if (fieldName == null)
         return "";
      if (fieldName.length() <= 10)
         return fieldName;

      return fieldName.substring(0, 10);
   }

   public String getFieldID() {
      return fieldID != null ? fieldID : "";
   }

   public String getFieldName() {
      return fieldName != null ? fieldName : "";
   }

   public String getFieldType() {
      return fieldType != null ? fieldType : "";
   }

   public SS3Note getNote() {
      return note;
   }

   public String getNoteID() {
      return note.getID() != null ? note.getID() : "";
   }

   public String getNoteSubject() {
      return note.getSubject() != null ? note.getSubject() : "";
   }

   public String getNoteInitialText() {
      return note.getBody() != null ? note.getBody() : "";
   }

   public SS3Participant getAuthor() {
      String coderID = note.getCoderID();
      Manager mng = SS3Singleton.getManager();
      ParticipantsLibrary lib = mng.getLoadedParticipantsLibrary();
      SS3Participant part = lib.getParticipant(coderID);
      return part;
   }
}
