package edu.bu.signstream.grepresentation.fields;

import java.util.ArrayList;

public class SegmentCollection {

	private ArrayList collection;

	public SegmentCollection() {
		this.collection = new ArrayList();
	}

	public void addSegment(Segment segment) {
		collection.add(segment);
	}

	public int getSize() {
		return collection.size();
	}

	public Event getSelectedEvent() {
		Event event = null;
		for (int i = 0; i < collection.size(); i++) {
			Segment segment = (Segment) collection.get(i);
			FieldWrappersCollection col = segment.getFieldWrappersCollection();
			event = col.getSelectedEvent();
			if (event != null)
				return event;
		}
		return null;
	}

	public FieldWrapper getFieldWrapperAt(int Y) {
		for (int i = 0; i < collection.size(); i++) {
			Segment segment = (Segment) collection.get(i);
			FieldWrapper wrapper = segment.getFieldWrapperAt(Y);
			if (wrapper != null)
				return wrapper;
		}
		return null;
	}

	//	public int getStartTime() {
	//		int startTime = 0;
	//		int sStartTime = 0;
	//
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			sStartTime = segment.getStartTime();
	//			startTime = startTime < sStartTime ? startTime : sStartTime;
	//		}
	//
	//		return startTime;
	//	}
	//
	//	public int getEndTime() {
	//		int endTime = 0;
	//		int sEndTime = 0;
	//
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			sEndTime = segment.getEndTime();
	//			endTime = endTime > sEndTime ? endTime : sEndTime;
	//		}
	//
	//		return endTime;
	//	}
	//
	//	public int getStartTimeCoordinate() {
	//		int startTime = 0;
	//		int sStartTime = 0;
	//
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			sStartTime = segment.getStartTimeCoordinate();
	//			startTime = startTime < sStartTime ? startTime : sStartTime;
	//		}
	//
	//		return startTime;
	//	}
	//
	//	public int getEndTimeCoordinate() {
	//		int endTime = 0;
	//		int sEndTime = 0;
	//
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			sEndTime = segment.getEndTimeCoordinate();
	//			endTime = endTime > sEndTime ? endTime : sEndTime;
	//		}
	//
	//		return endTime;
	//	}
	//
	//	public void selectEntity(Point point) {
	//		unselect();
	//		for (int i = 0; i < collection.size(); i++) {
	//			NonManualField entity = getTrackEntityAt(point.y);
	//			if (entity != null) {
	//				ChainedEventsEntity ceEntity =
	//					entity.getChainedEventsEntityAt(point.x);
	//				if (ceEntity != null)
	//					ceEntity.select();
	//			}
	//		}
	//	}
	//
	//	public void selectChainedEvent(Point point) {
	//		unselect();
	//		for (int i = 0; i < collection.size(); i++) {
	//			NonManualField entity = getTrackEntityAt(point.y);
	//			if (entity != null) {
	//				ChainedEventsEntity ceEntity =
	//					entity.getChainedEventsEntityAt(point.x);
	//				if (ceEntity != null) {
	//					ChainedEvent event = ceEntity.getChainedEventAt(point.x);
	//					if (event != null)
	//						event.select();
	//				}
	//			}
	//		}
	//	}
	//
	//	public Event getSelectedEvent() {
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//
	//			if (segment.getSelectedEvent() != null)
	//				return segment.getSelectedEvent();
	//		}
	//
	//		return null;
	//	}
	//
	//	public ChainedEventsEntity getSelectedEntity() {
	//		ChainedEventsEntity entity = null;
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//
	//			if ((entity = segment.getSelectedEntity()) != null)
	//				return entity;
	//		}
	//		return null;
	//	}
	//
	//	public void unselect() {
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			segment.unselect();
	//		}
	//	}
	//
	//	public void reset() {
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			segment.reset();
	//		}
	//	}
	//
	//	public void addNewChainedEvent(Point point) {
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			segment.addNewChainedEvent(point);
	//		}
	//	}
	/*
		public void setValueID(String valueID, Point point) {
			for (int i = 0; i < collection.size(); i++) {
				Segment segment = (Segment) collection.get(i);
				segment.setValueID(valueID, point);
			}
		}
	*/

	//	public boolean canDrawNewEvent(Point point) {
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			if (segment.canDrawNewEvent(point))
	//				return true;
	//		}
	//		return false;
	//	}
	//
	//	public String getFieldID(Point point) {
	//		NonManualField entity = getTrackEntityAt(point.y);
	//
	//		if (entity != null)
	//			return entity.getFieldID();
	//		return null;
	//	}
	//
	//	public String getToolTipText(Point point) {
	//		NonManualField entity = getTrackEntityAt(point.y);
	//
	//		if (entity != null)
	//			return entity.getToolTipText(point.x);
	//
	//		return "";
	//	}

	//	public NonManualField getTrackEntityAt(int y) {
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//
	//			if (segment.contains(y))
	//				return segment.getTrackEntityAt(y);
	//		}
	//		return null;
	//	}

	//	public NewChainedEvent getNewChainedEvent() {
	//		NewChainedEvent event = null;
	//		for (int i = 0; i < collection.size(); i++) {
	//			Segment segment = (Segment) collection.get(i);
	//			if ((event = segment.getNewChainedEvent()) != null)
	//				return event;
	//		}
	//		return event;
	//	}

	//	public Segment getSegment(int segmentID) {
	//		return (Segment) collection.get(segmentID);
	//	}

	public ArrayList getCollapsedSegments() {
		ArrayList collapsed = new ArrayList();
		for (int i = 0; i < collection.size(); i++) {
			Segment segment = (Segment) collection.get(i);
			if (segment.isCollapsed())
				collapsed.add(segment);
		}
		return collapsed;
	}

	public ArrayList getSegmentsToShow() {
		ArrayList toShow = new ArrayList();
		for (int i = 0; i < collection.size(); i++) {
			Segment segment = (Segment) collection.get(i);
			if (!segment.isCollapsed())
				toShow.add(segment);
		}
		return toShow;
	}
}
