package edu.bu.signstream.grepresentation.fields.apexField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.apexField.ApexChainedApexEvent;
import edu.bu.signstream.grepresentation.fields.apexField.ApexChainedApexEventsEntity;
import edu.bu.signstream.grepresentation.fields.apexField.ApexField;
import edu.bu.signstream.grepresentation.fields.apexField.ApexFieldWrapper;
import edu.bu.signstream.grepresentation.fields.apexField.ChainedApexEventsCollection;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.GestureNRelatedView;
import edu.bu.signstream.grepresentation.view.LabelObject;

public class AddApexActionListener implements ActionListener {
	private GestureNRelatedView gestureView = null;
	private GestureEventsEntity selectedEntity = null;

	public AddApexActionListener(GestureNRelatedView gestureView, GestureEventsEntity selectedEntity) {
		this.gestureView = gestureView;
		this.selectedEntity = selectedEntity;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		var segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

		Event gestureTextEvent = selectedEntity.getValueOrTextValueEvent();

		LabelObject gestObj = gestureView.getSegment().getRootLabelObject().getGestureLabelObject();
		
		ApexFieldWrapper apexWrapper;
		if (selectedEntity.getField().getFieldID().equals(Util.DOM_GESTURE_FIELD_ID)) {
			apexWrapper = (ApexFieldWrapper) gestObj
					.getChildWithFieldID(Util.DOM_GESTURE_APEX_FIELD_ID).getWrapper();
		} else {
			apexWrapper = (ApexFieldWrapper) gestObj
					.getChildWithFieldID(Util.NDOM_GESTURE_APEX_FIELD_ID).getWrapper();
		}

        var start = gestureTextEvent.getStartTimeInfo();
        var end = gestureTextEvent.getEndTimeInfo();

        var quarter = end.distance(start).divide(4);
        var newStart = start.add(quarter);
        var newEnd = end.subtract(quarter);

		ApexChainedApexEvent textEvent = new ApexChainedApexEvent(segmentPanel);
		textEvent.setText("apex");
		textEvent.setStartTimeInfo(newStart);
		textEvent.setEndTimeInfo(newEnd);
        textEvent.select();

        ChainedApexEventsCollection collection = new ChainedApexEventsCollection();
		collection.setTextValueEvent(textEvent);
		
		ApexChainedApexEventsEntity apexEntity = new ApexChainedApexEventsEntity(collection, segmentPanel, apexWrapper.getField());
        apexEntity.updateParentEntity();
		apexEntity.setStartTimeInfo(newStart);
		apexEntity.setEndTimeInfo(newEnd);
        apexEntity.select();

		((ApexField)apexWrapper.getField()).addChainedApexEventEntity(apexEntity);
		selectedEntity.setDependentApexEntity(apexEntity);

		SS3Singleton.getMediaToolBar(segmentPanel)
            .selectEvent(textEvent, apexEntity, apexEntity.getField());

		SS3Singleton.getMediaPlayer().seek(newStart);
        
        SS3Singleton.getMediaToolBar().segmentPanel().getUtteranceView().getSegmentTemplate(
        	selectedEntity.getField().getSegmentID()).getNonmanView()
        	.getCSFieldDialog().getCSFieldPanel().showAllFieldsCurrentUtterance();
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
	}
}
