package edu.bu.signstream.grepresentation.fields.freeTextField;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.Track;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Track;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsCollection;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntityCollection;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

/**
 * Text fields contain textual information that is NOT ALIGNED to the video.
 * Predefined text fields are the "literal translation" field and the "English translation" field. 
 * 
 * */

public class FreeTextField extends NonManualField {
   public FreeTextField(Track track, SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(track, segmentPanel, parentField);
   }

	public FreeTextField(
      SS3Track ss3track,
      SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(ss3track, segmentPanel, parentField);
      createTrackEntities(ss3track);
   }

   private void createTrackEntities(SS3Track ss3track) {
      ArrayList chainedEvents = new ArrayList();
      ArrayList entities = ss3track.getEntities();
      for (int j = 0; j < entities.size(); j++) {
         SS3Entity entity = (SS3Entity) entities.get(j);
         ChainedEventsCollection eventsCollection = new ChainedEventsCollection();

         ArrayList items = entity.getItemsAsList();
         for (int i = 0; i < items.size(); i++) {
            SS3Item item = (SS3Item) items.get(i);
            // String id = item.getId();
            //Event parentEvent = SS3Singleton.getMediaToolBar(null).getSelectedParentEvent();
            Event selectedEvent = SS3Singleton.getMediaToolBar(null).selectedEvent();



            eventsCollection.setTextValueEvent(new FreeTextEvent(item, segmentPanel));
         }

         FreeTextEntity textEntity =
            new FreeTextEntity(eventsCollection, ss3track.getId(), segmentPanel, this);
         textEntity.setID(entity.getID());
         textEntity.setRefEntityId(entity.getRefEntityId());
         textEntity.setValidTime(entity.isValidTime());
         //textEntity.setReference(entity.getReference());
         textEntity.setParentEntities(getParentField().getEntities(entity.getParentEntityIDs()));
         chainedEvents.add(textEntity);
      }
 
      collection = new ChainedEventsEntityCollection(chainedEvents, segmentPanel);
   }
   
   @Override
public void addChainedEventEntity(ChainedEventsEntity entity) {
      FreeTextEntity lEntity =
         new FreeTextEntity(
            entity.getChainedEventsCollection(),
            getFieldID(),
            segmentPanel, this);
      lEntity.updateParentEntity();
      lEntity.setValidTime(true);

      super.addEventsEntity(lEntity); //..addEntity(lEntity);
   }
   
   public void addFreeTextEntity(FreeTextEntity textEntity) {
	   collection.addEntity(textEntity);
   }
}
