package edu.bu.signstream.grepresentation.fields.gestureField;

import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.view.SegmentGraphicRepresentation;
import edu.bu.signstream.grepresentation.view.SegmentTemplate;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class NewGestureEvent extends NewGestureChainedEvent {

   private JTextField tf = new JTextField();

   public NewGestureEvent(
      final int X1,
      final SignStreamSegmentPanel segmentPanel,
      final GestureField field) {
      super(TimeRange.ABSOLUTE.time(X1, TimeUnit.COORDINATE), segmentPanel);

      int w = 300;

      tf.setSize(w, 18);
      tf.setPreferredSize(new Dimension(w, 18));
      tf.setMinimumSize(new Dimension(w, 18));

      // do not remove - java error!!!
      tf.setText(" ... ");
      tf.setText(" ");
      
      SegmentTemplate template = segmentPanel.getUtteranceView().getSegmentTemplate(field.getSegmentID());
      SegmentGraphicRepresentation rep = template.getSignView().getSegmentGraphicRep();
      rep.passivateMouseListener();

      Action addGestureEvent = new AbstractAction() {
         @Override
		public void actionPerformed(ActionEvent e) {
            GestureEnteredText enteredText =
               field.getGestureEventsEntityCollection().getEnteredText();
            if (enteredText != null) {
               //enteredText.addString(tf.getText(), X1);
            } else {
//               enteredText =
//                  new EnteredText(tf.getText(), X1, segmentPanel, field);
//               field.getGestureChainedEventsEntityCollection().setEnteredTextObject(
//                  enteredText);
            }           
            /*
                        GestureEvent textValue = new GestureEvent(segmentPanel);
                        textValue.setStartTimeCoordinate(X1);
                        textValue.setEndTimeCoordinate(X1 + 33);
                        textValue.setText(tf.getText());
                        GestureChainedEventsCollection collection = new GestureChainedEventsCollection();
                        collection.setTextValueEvent(textValue);
            
                        GestureChainedEventsEntity entity =
                           new GestureChainedEventsEntity(
                              collection,
                              field.getFieldID(),
                              segmentPanel);
                              
                        field.addGestureChainedEventEntity(entity);      
            */
            field.setNewGestureEvent(null);
            //SegmentGraphicRepresentation rep =
            //   segmentPanel.getView().getSegmentView2().getSegmentGraphicRep();          
            SegmentTemplate template = segmentPanel.getUtteranceView().getSegmentTemplate(field.getSegmentID());
            SegmentGraphicRepresentation rep = template.getSignView().getSegmentGraphicRep();
            rep.activateMouseListener();
            segmentPanel.repaint();
         }
      };

      tf.getInputMap().put(
         KeyStroke.getKeyStroke("pressed ENTER"),
         "addGestureEvent");
      tf.getActionMap().put("addGestureEvent", addGestureEvent);
   }

   public JTextField getTextField() {
      return tf;
   }
}
