package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.util.ArrayList;

import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.OrientationImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;

/**
 * This class is used to store the handshape images selected by the user in the handshape palette. It also stores the orientation images selected by the user in the orientation palette.
 */
public class GestureHandShapeBean {

	private char type;

    private boolean isRightHandSelected = true;

    private boolean updated = false;

	private ArrayList<HandShapeImage> selectedDomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> selectedNdomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<OrientationImage> selectedDomOrientationFingerTipImages = new ArrayList<>();
	private ArrayList<OrientationImage> selectedNdomOrientationFingerTipImages = new ArrayList<>();
	private ArrayList<OrientationImage> selectedDomOrientationPalmImages = new ArrayList<>();
	private ArrayList<OrientationImage> selectedNdomOrientationPalmImages = new ArrayList<>();

    public void setUpdated(boolean updated) {
        this.updated = updated;
    }

	public boolean getUpdated() {
		return this.updated;
	}

    public boolean isUpdated() {
        return updated;
    }

    public void clearNdomHandShapeImages() {
        selectedNdomHandShapeImages.clear();
    }

    public void clearDomHandShapeImages() {
        selectedDomHandShapeImages.clear();
    }
    
    public void clearDomOrientationFingerTipImages() {
		selectedDomOrientationFingerTipImages.clear();
    }
    
    public void clearNdomOrientationFingerTipImages() {
		selectedNdomOrientationFingerTipImages.clear();
    }

	public void clearDomOrientationPalmImages() {
		selectedDomOrientationPalmImages.clear();
	}

	public void clearNdomOrientationPalmImages() {
		selectedNdomOrientationPalmImages.clear();
	}

    public void setRightHandSelected(boolean isRightHandSelected) {
        this.isRightHandSelected = isRightHandSelected;
    }

	/**
	 * @return
	 */
	public ArrayList<HandShapeImage> getSelectedNdomHandShapeImages() {
		return selectedNdomHandShapeImages;
	}

	/**
	 * @return
	 */
	public ArrayList<HandShapeImage> getSelectedDomHandShapeImages() {
		return selectedDomHandShapeImages;
	}

	public ArrayList<OrientationImage> getSelectedDomOrientationFingerTipImages() {
		return selectedDomOrientationFingerTipImages;
	}

	public ArrayList<OrientationImage> getSelectedNdomOrientationFingerTipImages() {
		return selectedNdomOrientationFingerTipImages;
	}

	public ArrayList<OrientationImage> getSelectedDomOrientationPalmImages() {
		return selectedDomOrientationPalmImages;
	}

	public ArrayList<OrientationImage> getSelectedNdomOrientationPalmImages() {
		return selectedNdomOrientationPalmImages;
	}

	/**
	 * @return
	 */
	public char getType() {
		return type;
	}

	/**
	 * @param list
	 */
	public void setSelectedNdomHandShapeImages(ArrayList<HandShapeImage> list) {
		clearNdomHandShapeImages();
		selectedNdomHandShapeImages.addAll(list);
	}

	/**
	 * @param list
	 */
	public void setSelectedDomHandShapeImages(ArrayList<HandShapeImage> list) {
		clearDomHandShapeImages();
		selectedDomHandShapeImages.addAll(list);
	}

	public void setSelectedNdomOrientationFingerTipImages(ArrayList<OrientationImage> list) {
		clearNdomOrientationFingerTipImages();
		selectedNdomOrientationFingerTipImages.addAll(list);
	}

	/**
	 * @param list
	 */
	public void setSelectedDomOrientationFingerTipImages(ArrayList<OrientationImage> list) {
		clearDomOrientationFingerTipImages();
		selectedDomOrientationFingerTipImages.addAll(list);
	}

	public void setSelectedDomOrientationPalmImages(ArrayList<OrientationImage> list) {
		clearDomOrientationPalmImages();
		selectedDomOrientationPalmImages.addAll(list);
	}

	public void setSelectedNdomOrientationPalmImages(ArrayList<OrientationImage> list) {
		clearNdomOrientationPalmImages();
		selectedNdomOrientationPalmImages.addAll(list);
	}

	/**
	 * @param c
	 */
	public void setType(char c) {
		type = c;
	}
}
