package edu.bu.signstream.grepresentation.fields.gestureField.locationField;

import edu.bu.signstream.time.Time;

import java.util.ArrayList;

public class GestureLocationEventsCollection {

    private ArrayList<GestureLocationEvent> events = new ArrayList<GestureLocationEvent>();

    public GestureLocationEventsCollection() {
        resetAll();
    }

    public void addEvent(GestureLocationEvent event) {
        events.add(event);
    }

    public GestureLocationEvent getEvent(int idx) {
        return events.get(idx);
    }

    public GestureLocationEvent getFirstEvent() {
        return events.get(0);
    }

    public GestureLocationEvent getLastEvent() {
        return events.get(events.size() - 1);
    }

    public boolean adjustEntity(Time startTimeInfo, Time endTimeInfo) {
        GestureLocationEvent fEvent = getFirstEvent();
        GestureLocationEvent lEvent = getLastEvent();

        if (fEvent == null || lEvent == null)
            return false;

        fEvent.setStartTimeInfo(startTimeInfo);
        lEvent.setEndTimeInfo(endTimeInfo);
        return true;
    }

    public void resetAll() {
        events.clear();
    }

    public boolean deleteAll() {
        resetAll();
        return true;
    }

    public ArrayList<GestureLocationEvent> getEvents() {
        return new ArrayList<GestureLocationEvent>(events);
    }

    public int size() {
        return events.size();
    }
}
