package edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.gesturePropertyField.GesturePropertyEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class AddGesturePreparationActionListener implements ActionListener {
	private GestureChainedEventsEntity selectedEntity = null;

	public void setSelectedEntity(GestureChainedEventsEntity entity) {
		this.selectedEntity = entity;
	}

	@Override
	public void actionPerformed(ActionEvent e) {

//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton
				.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time minPreparationStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getPrecedingFrameTimeInfo(
//						selectedEntity.getStartTimeInfo());

//		if (minPreparationStartTimeInfo.lessThan(utterance.getStartTimeInfo())) {
//			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//		}
			
		GestureChainedEventsEntity prevEntity = selectedEntity.getPreviousEntity();
		if(prevEntity != null) {
			Time minPreparationMovieTimeInfo = segmentPanel.getMultipleMovieController().getFollowingFrameTimeInfo(
					prevEntity.getEndTimeInfo());
			if(selectedEntity.getStartTimeInfo().lessThan(minPreparationMovieTimeInfo)) {
				SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
				return;
			}
		}

		String seWarning = selectedEntity.addPreparationEvent();
		if (seWarning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(seWarning);
			return;
		}
		Event selectedEvent = selectedEntity.getPreparation();
		selectedEntity.getValueOrTextValueEvent().unselect();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar();
        mToolBar.select(selectedEvent, selectedEntity);

		var currentTime = selectedEvent.getStartTimeInfo();
		SS3Singleton.getMediaPlayer().seek(currentTime);

		if(selectedEntity instanceof GestureEventsEntity) {
			GestureEventsEntity gestSelectedEntity = (GestureEventsEntity)selectedEntity;
			
			if(gestSelectedEntity.isLockedDomNdomAlignments()) {
				GestureEventsEntity ndGestEntity = gestSelectedEntity.getDependentGestureEntity();
				if(ndGestEntity != null && ndGestEntity.getPreparation() == null) {
					String ndGestWarning = ndGestEntity.addPreparationEvent();
					if(ndGestWarning != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(ndGestWarning);	
					}
				}
			}

			GestureLocationEntity depLocEntity = gestSelectedEntity.getDependentLocationEntity();
			if (depLocEntity != null) {
				depLocEntity.updateTimes();
			}
			
			GesturePropertyEntity depSignTypeEnt = gestSelectedEntity.getDependentGesturePropertyEntity();
			if (depSignTypeEnt != null) {
				depSignTypeEnt.updateTimes();
			}
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
	}
}