package edu.bu.signstream.grepresentation.fields.glossField;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.MorphologicalPhonologicalInfoDialog;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.grepresentation.fields.nonManualField.MouseDblRightClickedDelegate;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.GlossNRelatedView;

public class GlossMouseDblRightClickedDelegate extends
		MouseDblRightClickedDelegate {

	private GlossFieldWrapper wrapper = null;
	private GlossNRelatedView glsView = null;

	public GlossMouseDblRightClickedDelegate(NonManualField nmField,
			GlossFieldWrapper wrapper, GlossNRelatedView glsView) {
		super(nmField);
		this.wrapper = wrapper;
		this.glsView = glsView;
	}

	/**
     * Shows Morphological Phonological Information Dialog
     * @param event selected gloss text event
     */
    public void controlAltDblClick(ChainedEvent event, GlossFieldWrapper wrapper, GlossNRelatedView glsView) {
        event.select();
            MorphologicalPhonologicalInfoDialog dialog = SS3Singleton.getNonManuelFieldDialogs().getMorphologicalPhonologicalInfoDialog();

            if(dialog == null) {
                dialog = new MorphologicalPhonologicalInfoDialog(wrapper, glsView);
                dialog.setResizable(false);
                SS3Singleton.getNonManuelFieldDialogs().setMorphologicalPhonologicalInfoDialog(dialog);
            } else {
                dialog.update(wrapper, glsView);
            }

        dialog.setVisible(true);
        dialog.setLocationRelativeTo(null);
        //dialog.setLocation(150, 150);
        dialog.setLocation(15, 15);
	}
    
    public void dblClick(
    	      ChainedEvent event,
    	      final GlossChainedEventsEntity glsEntity,
    	      final Point point,
    	      final JPanel panel) {

    		   if(event == null)
    			   return;
    		   
    	      Event value = glsEntity.getValueOrTextValueEvent();
    	      Event iHold = glsEntity.getInitialHold();
    	      Event fHold = glsEntity.getFinalHold();
    	      Event onset = glsEntity.getOnset();
    	      Event offset = glsEntity.getOffset();

    	      if (event.equals(value)) {
    	    	  SS3Singleton.getNonManuelFieldDialogs().getAssociatedElelmentsMenu(glsEntity, point, panel);
    	         //valueDblClick(event, glsEntity, point, panel);
    	      } else {
    	         final JPopupMenu popup = new JPopupMenu();
    	         JMenuItem mi = null;
    	         
    	         if (event.equals(iHold)) {
    	            mi = new JMenuItem("Delete Initial Hold");
    	            mi.addActionListener(new ActionListener() {
    	            @Override
    				public void actionPerformed(ActionEvent e) {
    	     		   glsEntity.deleteInitialHold();
    	     		   SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
    	     		   panel.repaint();
    	               }
    	            });
    	         } else if (event.equals(fHold)) {
    	            mi = new JMenuItem("Delete Final Hold");
    	            mi.addActionListener(new ActionListener() {
    	               @Override
    				public void actionPerformed(ActionEvent e) {
    	        		   glsEntity.deleteFinalHold();
    	        		   SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
    	        		   panel.repaint();
    	               }
    	            });
    	         } else if (event.equals(onset)) {
    	            mi = new JMenuItem("Delete Onset");
    	            mi.addActionListener(new ActionListener() {
    	               @Override
    				public void actionPerformed(ActionEvent e) {
    	     		   glsEntity.deleteOnset();
    	     		   SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
    	     		   panel.repaint();
    	               }
    	            });
    	         } else if (event.equals(offset)) {
    	            mi = new JMenuItem("Delete Offset");
    	            mi.addActionListener(new ActionListener() {
    	               @Override
    				public void actionPerformed(ActionEvent e) {
    	     		   glsEntity.deleteOffset();
    	     		   SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
    	     		   panel.repaint();
    	               }
    	            });
    	         }
    	         UserInterfaceUtil.setMenuItemLNF(mi);
    	         popup.add(mi);
    	         JMenuItem cancel = new JMenuItem("Cancel");
    	         UserInterfaceUtil.setMenuItemLNF(cancel);
    	         popup.add(cancel);
    	         popup.setPreferredSize(popup.getPreferredSize());
    	         popup.show(panel, point.x, point.y);
    	         popup.setVisible(true);
    	 		
    	 		SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
    	      }
    	   }
}
