package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;

import javax.swing.Icon;

public class SameWidhtIcon implements Icon {

	private int width = 40;
	private int height = 29;

	private Image image = null;

	public SameWidhtIcon(Image image) {
		this.image = image;
	}

	@Override
	public void paintIcon(Component c, Graphics g, int x, int y) {
		Graphics2D g2d = (Graphics2D) g.create();

		g2d.setColor(Color.BLACK);
		g2d.fillRect(x, y, width, height);

		int s = 0;
		
		int imgWidth = image.getWidth(null);
		if (imgWidth < width) {
			s = (width - imgWidth) / 2;
		}

		int s2 = 0;
		int imgHeight = image.getHeight(null);
		if (imgHeight < height) {
			s2 = (height - imgHeight) / 2;
		}

		g2d.drawImage(image, s, s2, null);
		
		g2d.dispose();
	}

	@Override
	public int getIconWidth() {
		return width;
	}

	@Override
	public int getIconHeight() {
		return height;
	}
		
	public void flush() {
		if(image != null) {
			image.flush();
			image = null;
		}
	}
}