package edu.bu.signstream.grepresentation.fields.glossField.dialog.handShapes;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.FingerTipImage;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.OrientationImage;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.PalmImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;

public class HandShapesPaletteFormBean {
	private ArrayList<SS3FieldValue> handValues = new ArrayList<>();

	private ArrayList<HandShapeImage> selectedHshImages = new ArrayList<>();
	private String title = "";
	private boolean rHandSelected = true;

	private ArrayList<FingerTipImage> selectedFingerTipOrientationImages = new ArrayList<>();
	private ArrayList<PalmImage> selectedPalmOrientationImages = new ArrayList<>();
   
//   private String languageID = "0";
//   private String languageHandshapesType = "A";
//   private boolean unmarked = false;
    private boolean fingerspelled = false;

    public enum PaletteType {
        RIGHT,
	    LEFT,
	    RIGHT_N_LEFT;
    }

    private PaletteType paletteType;
   
    private int paletteID = 0;
   
    private SS3CodingScheme codingScheme = null;

	public boolean isRightHandSelected() {
		return rHandSelected;
	}
	
	public void setPaletteID(int paletteID) {
		this.paletteID = paletteID;
	}

	public int getPaletteID() {
		return paletteID;
	}

	public PaletteType getPaletteType() {
		return paletteType;
	}

	public void setPaletteType(PaletteType paletteType) {
		this.paletteType = paletteType;
	}

	public String getTitle() {
		return title;
	}

	public ArrayList<SS3FieldValue> getValues() {
		return handValues;
	}

	public void setValues(ArrayList handValues) {
		this.handValues = handValues;
	}

	public void setRightHandSelected(boolean b) {
		rHandSelected = b;
	}

	public void setTitle(String string) {
		title = string;
	}
	
	public ArrayList<HandShapeImage> getSelectedHshImages() {
		return selectedHshImages;
	}

	public ArrayList<FingerTipImage> getSelectedFingerTipOrientationImages() {
		return selectedFingerTipOrientationImages;
	}

	public ArrayList<PalmImage> getSelectedPalmOrientationImages() {
		return selectedPalmOrientationImages;
	}

	public void setSelectedHshImages(ArrayList list) {
//		this.selectedHshImages = list;
		this.selectedHshImages.clear();
		this.selectedHshImages.addAll(list);
	}

	public void setSelectedFingerTipOrientationImages(ArrayList list) {
		this.selectedFingerTipOrientationImages.clear();
		this.selectedFingerTipOrientationImages.addAll(list);
	}

	public void setSelectedPalmOrientationImages(ArrayList<PalmImage> palmOrientationImages) {
		this.selectedPalmOrientationImages.clear();
		this.selectedPalmOrientationImages.addAll(palmOrientationImages);
	}

   public SS3CodingScheme getCodingScheme() {
      return codingScheme;
   }

   public void setCodingScheme(SS3CodingScheme scheme) {
      codingScheme = scheme;
   }

   public boolean isFingerspelled() {
      return fingerspelled;
   }

   public void setFingerspelled(boolean b) {
      fingerspelled = b;
   }
}
