package edu.bu.signstream.grepresentation.fields.handShapeField.dialogs;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.Icon;
import javax.swing.JPanel;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.PaletteUtil;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.SortedHandshapesPalette;

public class HandShapePalette extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	private HandShapePalletClient hsClient;
	private HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();

	public HandShapePalette(ArrayList<SS3FieldValue> handshapes,
			HandShapePalletClient hsClient, SS3CodingScheme scheme) {
		this.hsClient = hsClient;
		
		PaletteUtil paletteUtil = new PaletteUtil(scheme, hsClient);

		SortedHandshapesPalette palette = new SortedHandshapesPalette(handshapes, paletteUtil);
		setLayout(new BorderLayout());
		add(palette, BorderLayout.CENTER);
		
		revalidate();
		repaint();
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();
		SS3FieldValue value = hm.get(str);
		hsClient.setItem(value);
//		SS3Singleton.getApplicationStateController()
//				.setLoadedCollectionUpdated(true);
	}
}

class MissingIcon implements Icon {

	private int width = 32;
	private int height = 32;

	private Color color = Color.WHITE;

	public MissingIcon(Dimension iconDimension, Color color) {
		this.width = iconDimension.width;
		this.height = iconDimension.height;
		this.color = color;
	}

	@Override
	public void paintIcon(Component c, Graphics g, int x, int y) {
		Graphics2D g2d = (Graphics2D) g.create();

		g2d.setColor(color);
		g2d.fillRect(x + 1, y + 1, width - 2, height - 2);

		g2d.dispose();
	}

	@Override
	public int getIconWidth() {
		return width;
	}

	@Override
	public int getIconHeight() {
		return height;
	}
}
