package edu.bu.signstream.grepresentation.fields.handShapes.joints;

import java.awt.Point;
import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.Track;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Track;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class JointsField extends NonManualField {

   public JointsField(SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(segmentPanel, parentField);
   }

   public JointsField(Track track, SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(segmentPanel, parentField);
      this.track = track;
      createTrackEntity(track);
   }

   public JointsField(SS3Track ss3track, SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(segmentPanel, parentField);
      this.ss3Track = ss3track;
      createTrackEntity(ss3track);
   }
   
   @Override
public void deleteEmptyEntities() {
   }

   @Override
public void unselect() {
      ArrayList entities = collection.getEntities();

      for (int i = 0; i < entities.size(); i++) {
         JointsEventsEntity entity = (JointsEventsEntity) entities.get(i);
         entity.unselect();
         ArrayList events = entity.getEvents();
         for (int j = 0; j < events.size(); j++) {
            JointsEvent event = (JointsEvent) events.get(j);
            event.unselect();
         }
      }
   }

   public JointsEvent getEventAt(Point point) {
      ArrayList entities = collection.getEntities();

      for (int i = 0; i < entities.size(); i++) {
         JointsEventsEntity entity = (JointsEventsEntity) entities.get(i);
         ArrayList events = entity.getEvents();
         for (int j = 0; j < events.size(); j++) {
            JointsEvent event = (JointsEvent) events.get(j);
            if (event.contains(point.x))
               return event;
         }
      }
      return null;
   }
   
   @Override
public Event getSelectedEvent() {
      ArrayList entities = collection.getEntities();

      for (int i = 0; i < entities.size(); i++) {
         JointsEventsEntity entity = (JointsEventsEntity) entities.get(i);
         ArrayList events = entity.getEvents();
         for (int j = 0; j < events.size(); j++) {
            JointsEvent event = (JointsEvent) events.get(j);
            if (event.isSelected())
               return event;
         }
      }
      return null;  
   }

   @Override
protected void createTrackEntity(SS3Track track) {}

   private void createTrackEntity(Track track) {}

}
