package edu.bu.signstream.grepresentation.fields.legacyGlossField;

import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.grepresentation.fields.glossField.GlossField;
import edu.bu.signstream.grepresentation.fields.glossField.GlossFieldWrapper;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualFieldWrapper;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class LegacyGlossFieldWrapper extends NonManualFieldWrapper {
   private GlossFieldWrapper manualGlossFieldWrp;
   private GlossFieldWrapper ndHandGlossFieldWrp;
   

   public LegacyGlossFieldWrapper(GlossField nmField, SignStreamSegmentPanel segmentPanel, TimeRange timeRange) {
      super(nmField, segmentPanel, timeRange);
   }

   public GlossFieldWrapper getManualGlossFieldWrapper() {
      return manualGlossFieldWrp;
   }

   public void setManualGlossFieldWrapper(GlossFieldWrapper manualGlossFieldWrp) {
      this.manualGlossFieldWrp = manualGlossFieldWrp;
   }

   public GlossFieldWrapper getNdHandGlossFieldWrapper() {
      return ndHandGlossFieldWrp;
   }

   public void setNdHandGlossFieldWrapper(GlossFieldWrapper ndHandGlossFieldWrp) {
      this.ndHandGlossFieldWrp = ndHandGlossFieldWrp;
   }

   // move selected entity to dominant or second gloss field, then delete
   @Override
public void mouseDblLeftClicked(final Point point, final JPanel panel) {
      final ChainedEventsEntity entity =
         (ChainedEventsEntity) nmField.getSelectedEntity();

      final JPopupMenu popup = new JPopupMenu();
      popup.add(new JLabel("main gloss"));
      popup.add(new JLabel("nd hand gloss"));
      popup.add(new JLabel("Delete"));
      popup.add(new JLabel("Cancel"));
      popup.setPreferredSize(popup.getPreferredSize());
      popup.show(panel, (int) point.getX(), (int) point.getY());
      popup.setVisible(true);
		
	  SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);

      popup.addMouseListener(new MouseAdapter() {
         @Override
		public void mousePressed(MouseEvent ev) {
            try {
               GlossFieldWrapper wrapper = null;

               int popupHeight = popup.getPreferredSize().height;
               int choosenHeight = ev.getPoint().y;
               int elementHeight = popupHeight / 4;
               int choosenEl = choosenHeight / elementHeight;

               if (choosenHeight % elementHeight == 0)
                  choosenEl--;
              
               if (choosenEl == 0) {
                  ChainedEventsEntity ent =
                     entity.clone(manualGlossFieldWrp.getField().getFieldID());                
                  manualGlossFieldWrp.addEventsEntity(ent);
                  nmField.deleteEntity(entity);
                  wrapper = manualGlossFieldWrp;
                  ent.getValueOrTextValueEvent().select();
               } else if (choosenEl == 1) {
            	   ChainedEventsEntity ent =
                       entity.clone(ndHandGlossFieldWrp.getField().getFieldID());
                  ndHandGlossFieldWrp.addEventsEntity(ent);
                  nmField.deleteEntity(entity);
                  wrapper = ndHandGlossFieldWrp;
                  ent.getValueOrTextValueEvent().select();
               } else if (choosenEl == 2) {
                  nmField.deleteEntity(entity);
               }
               panel.repaint();
               popup.setVisible(false);

               if (wrapper != null) {
                  //MorphologicalPhonologicalInfoDialog dialog =
                  //   new MorphologicalPhonologicalInfoDialog(wrapper);
                  //dialog.setResizable(false);
                  //dialog.show();
               }
               //
            } catch (Exception e) {
               // ignore. IndexOutOfBoundException will occur when user
               // will click on the border of the tool bar.
            }
         }
      });
   }

   //public void mouseClicked(Point point, JPanel panel) {
   //}

   @Override
public void mouseClickedAlt(Point point) {}

   public void mousePressedAlt(Point point) {}

   @Override
public void mouseMoved(Point point, JPanel panel) {}

   //public void mouseClicked(Point point) {
   //}

   //public void mouseRightClicked(Point point) {
   //}

   //public void mouseLeftClicked(Point point) {
   //}

   public void mouseDblClicked(Point point) {}

   @Override
public void mouseDblRightClicked(final Point point, final JPanel panel) {
      mouseDblLeftClicked(point, panel);
   }

   @Override
public void mouseReleased(Point point, final JPanel panel) {}

   @Override
public void mouseDragged(Point point, JPanel panel) {}
}
