package edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.SwingUtilities;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationFieldWrapper;
import edu.bu.signstream.grepresentation.fields.presentation.SegmentFieldWrapper;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;

public class DeletePresentationEntityActionListener implements ActionListener {
		private EventsEntity entity = null;
		private JPanel panel = null;
		private PresentationField field = null;
		private PresentationFieldWrapper wrapper = null;

		public DeletePresentationEntityActionListener(EventsEntity entity, PresentationField field, PresentationFieldWrapper wrapper, JPanel panel) {
			this.entity = entity;
			this.field = field;
			this.panel = panel;
			this.wrapper = wrapper;
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			final JPopupMenu popup = new JPopupMenu();

			JLabel msgLabel = new JLabel("Are you sure you want to delete the object?");
			UserInterfaceUtil.setLabelLNF(msgLabel);

			final JButton okBtn = new JButton("Proceed");
			final JButton cancelBtn = new JButton("Cancel");

			JPanel msgPanel = new JPanel();
			GridBagConstraints gbc = new GridBagConstraints();

			msgPanel.setLayout(new GridBagLayout());
			gbc.anchor = GridBagConstraints.WEST;

			gbc.gridwidth = 3;
			gbc.gridx = 0;
			gbc.gridy = 0;
			msgPanel.add(msgLabel, gbc);

			gbc.gridy = 1;
			gbc.gridx = 1;
			msgPanel.add(new JLabel(" "), gbc);

			gbc.gridwidth = 1;
			gbc.anchor = GridBagConstraints.EAST;
			gbc.gridy = 3;
			gbc.gridx = 0;
			msgPanel.add(new JLabel(" "), gbc);
			gbc.gridx = 1;
			msgPanel.add(okBtn, gbc);
			gbc.gridx = 2;
			msgPanel.add(cancelBtn, gbc);

			cancelBtn.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					popup.setVisible(false);
				}
			});

			okBtn.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					field.deleteEntity(entity);
					field.getSS3GlossWindowSegment().delete(entity);
//					wrapper.getSegmentPanel().getToolBarPanels().getMediaToolBar().selectEvent(null, null, field);
					SS3Singleton.getMediaToolBar().deselect();

					
					PresentationEventsEntity pEntity = (PresentationEventsEntity)entity;
					ArrayList<PresentationEventsEntity> entities = pEntity.getDependentEntities();
					
					ArrayList<SegmentFieldWrapper> depWrappers = wrapper.getSegmentsFieldWrappers();
					
					for(SegmentFieldWrapper wrp : depWrappers) {
						for(PresentationEventsEntity pEnt : entities) {
							PresentationField presField = (PresentationField)wrp.getField();
							presField.deleteEntity(pEnt);
							presField.getSS3GlossWindowSegment().delete(pEnt);
						}
					}		
					SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
					
					panel.repaint();
					popup.setVisible(false);
				}
			});

			SwingUtilities.invokeLater(new Runnable() {
				@Override
				public void run() {
					okBtn.requestFocus();
				}
			});

			int width = msgPanel.getPreferredSize().width + 30;
			int height = msgPanel.getPreferredSize().height + 20;

			popup.add(msgPanel);
			popup.setPopupSize(new Dimension(width, height));
			//popup.setLocation(entity.getStartTimeCoordinate(), field.getY());
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		
			popup.setLocation((int) ((screenSize.getWidth()-150)/2), (int) ((screenSize.getHeight()-150)/2));
			popup.setVisible(true);
			
			SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
		}
}
