package edu.bu.signstream.grepresentation.fields.presentation;

import edu.bu.signstream.grepresentation.fields.glossField.*;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.common.util.vo.ss3.db.*;
import edu.bu.signstream.common.util.Util;

public class PresentationEvent extends GlossChainedEvent {
	private SS3GlossWindowItem windowItem = null;

	public PresentationEvent(SS3GlossWindowItem windowItem,
			SignStreamSegmentPanel segmentPanel) {
		super(segmentPanel);
		this.windowItem = windowItem;
		this.id = windowItem.getId();
		this.text = windowItem.getLabel();
		this.startTimeInfo = windowItem.getStartTimeInfo();
		this.endTimeInfo = windowItem.getEndTimeInfo();

		if (this.id == null || id.length() < 1)
			this.id = Util.getLongUniqueNumber();
		
		windowItem.setEvent(this);
	}
	
	@Override
	public void setStartTimeInfo(Time timeInfo) {
		super.setStartTimeInfo(timeInfo);
		if (windowItem != null)
			this.windowItem.setStartTimeInfo(timeInfo);
	}
	
	@Override
	public void setEndTimeInfo(Time timeInfo) {
		super.setEndTimeInfo(timeInfo);
		if (windowItem != null)
			this.windowItem.setEndTimeInfo(timeInfo);
	}

	public PresentationEvent(SignStreamSegmentPanel segmentPanel) {
		super(segmentPanel);
		this.id = Util.getLongUniqueNumber();
	}
	
	public void setSS3GlossWindowItem(SS3GlossWindowItem windowItem) {
		this.windowItem = windowItem;
	}
	
	@Override
	public void setText(String text) {
		super.setText(text);
		if(windowItem!=null)
		windowItem.setLabel(text);
	}
	
	@Override
	public PresentationEvent clone() {
		SS3GlossWindowItem item = windowItem.clone();
		return new PresentationEvent(item, segmentPanel);
	}
	
	public SS3GlossWindowItem getSS3GlossWindowItem() {
		windowItem.setLabel(text);
		return windowItem;
	}
}
