package edu.bu.signstream.grepresentation.listener;

import edu.bu.signstream.ui.SS3SignStreamApplication;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.lang.ref.WeakReference;
import java.lang.reflect.Method;
import java.util.logging.Level;

public class WeakKeyListener implements KeyListener {

	private WeakReference<KeyListener> weakListenerReference;
	private Object source;

	public WeakKeyListener(KeyListener listener, Object source) {
		this.weakListenerReference = new WeakReference<KeyListener>(listener);
		this.source = source;
	}

	public void keyTyped(KeyEvent keyEvent) {
		KeyListener keyListener = getKeyListener();
		if (keyListener != null)
			keyListener.keyTyped(keyEvent);
	}

	public void keyPressed(KeyEvent keyEvent) {
		KeyListener keyListener = getKeyListener();
		if (keyListener != null)
			keyListener.keyPressed(keyEvent);
	}

	public void keyReleased(KeyEvent keyEvent) {
		KeyListener keyListener = getKeyListener();
		if (keyListener != null)
			keyListener.keyReleased(keyEvent);
	}

	private KeyListener getKeyListener() {
		KeyListener keyListener = (KeyListener) this.weakListenerReference
				.get();
		if (keyListener == null) {
			this.removeListener();
		}
		return keyListener;
	}

	private void removeListener() {
		try {
			Method method = source.getClass().getMethod("removeKeyListener",
					new Class[] { KeyListener.class });
			method.invoke(source, new Object[] { this });
		} catch (Exception ex) {
			ex.printStackTrace();
			SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
		}
	}
}
