package edu.bu.signstream.grepresentation.requestsHandler;

import java.awt.Point;

import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.IPAKeyboard;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.MorphologicalPhonologicalInfoDialog;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners.DeleteActionListener;

public class CustomFieldDialogs {

	final JPopupMenu popup = new JPopupMenu();

	private JMenuItem delete = null;
	private JMenuItem cancel = null;

	private DeleteActionListener deleteActionListener = null;
	
    // MorphologicalPhonologicalInfoDialog dialog is a singleton; keep it here.
    private MorphologicalPhonologicalInfoDialog morphologicalPhonologicalInfoDialog = null;
    
    private IPAKeyboard ipaKeyboard;

	public MorphologicalPhonologicalInfoDialog getMorphologicalPhonologicalInfoDialog() {
        return morphologicalPhonologicalInfoDialog;
    }

    public void setMorphologicalPhonologicalInfoDialog(MorphologicalPhonologicalInfoDialog morphologicalPhonologicalInfoDialog) {
        this.morphologicalPhonologicalInfoDialog = morphologicalPhonologicalInfoDialog;
    }
    
    public IPAKeyboard getIPAKeyboard() {
    	if (ipaKeyboard == null) {
    		ipaKeyboard = new IPAKeyboard();
    	}
		return ipaKeyboard;
	}

	public void getAssociatedElelmentsMenu(ChainedEventsEntity entity,
			Point point, JPanel panel) {
		
		delete = new JMenuItem("Delete");
		cancel = new JMenuItem("Cancel");
		
		UserInterfaceUtil.setMenuItemLNF(delete);
		UserInterfaceUtil.setMenuItemLNF(cancel);
		
		deleteActionListener = new DeleteActionListener();

		delete.addActionListener(deleteActionListener);
		
		popup.removeAll();
		popup.add(delete);
		popup.add(cancel);

		deleteActionListener.setChainedEventsEntity(entity);

		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);

		popup.show(panel, point.x, point.y);
		popup.setVisible(true);
		
		SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
	}
	
}
