package edu.bu.signstream.grepresentation.requestsHandler;

import edu.bu.signstream.common.db.parser.SS3Parser;
import edu.bu.signstream.common.util.vo.ss3.LoadedFilePaths;
import edu.bu.signstream.common.util.vo.ss3.dictionary.*;
import edu.bu.signstream.common.util.vo.ss3.participants.*;

import edu.bu.signstream.common.util.vo.ss3.media.SS3MediaLibrary;
//import edu.bu.signstream.common.db.parser.SS3Parser;


public class Manager {

	private ParticipantsLibrary prtLib;
	private ParticipantsLibrary antLib;

	private SS3Dictionary dictionary;
	private SS3MediaLibrary mediaLibrary;

	private LoadedFilePaths filePaths = new LoadedFilePaths();

	private RequestHandler rh = new RequestHandler();
	
	public RequestHandler getRequestHandler() {
		return rh;
	}

	public void loadParticipantsLibrary(String globalParticipantsFileName, String localParticipantsFileName) {
		SS3Parser parser = new SS3Parser();
		this.prtLib = parser.parseParticipantsLibrary(globalParticipantsFileName, localParticipantsFileName);
	}

	public ParticipantsLibrary getLoadedParticipantsLibrary() {
		if(prtLib == null) {
			return new ParticipantsLibrary();
		}
		return prtLib;
	}

	public void loadAnnotatorsLibrary(String globalAnnotatorsFileName, String localAnnotatorsFileName) {
		SS3Parser parser = new SS3Parser();
		this.antLib = parser.parseAnnotatorsLibrary(globalAnnotatorsFileName, localAnnotatorsFileName);
	}

	public ParticipantsLibrary getLoadedAnnotatorsLibrary() {
		if(antLib == null) {
			antLib = new ParticipantsLibrary();
		}
		
		return antLib;
	}

	public SS3Dictionary getLoadedDictionary() {
		dictionary = new SS3Dictionary();
		dictionary.addWord(new SS3Word("HOUSE"));
		dictionary.addWord(new SS3Word("MOUSE"));
		dictionary.addWord(new SS3Word("BOOK"));
		dictionary.addWord(new SS3Word("WOOD"));
		dictionary.addWord(new SS3Word("CAR"));
		dictionary.addWord(new SS3Word("PALM"));
		dictionary.addWord(new SS3Word("HAND"));
		return dictionary;
	}
}
