package edu.bu.signstream.media.data;

public enum Window {
    SQUARE {
        @Override
        public double coeff(int i, int n) {
            return 1;
        }
    },
    HANN {
        @Override
        public double coeff(int i, int n) {
            return 0.5 * (1 - Math.cos((2 * Math.PI * (i + 1)) / (n + 1)));
        }
    },
    GAUSSIAN {
        @Override
        public double coeff(int i, int n) {
            double mid = 0.5 * (n + 1);
            double edge = Math.exp(-12);
            double phase = ((i + 1) - mid) / (n + 1);
            return (Math.exp(-48 * phase * phase) - edge) / (1.0 - edge);
        }
    };

    public abstract double coeff(int i, int n);
}
