package edu.bu.signstream.time.ui;

import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.ui.popup.Popup;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;

public class TimeRangesEditDialog extends Popup {
    public TimeRangesEditDialog() {
        var panel = new JPanel();
        panel.setLayout(new GridBagLayout());


        var ranges = new ArrayList<TimeRange>();
        ranges.add(SS3Singleton.getVideoTimeRange());
        if (SS3Singleton.getAudioTimeRange() != null)
            ranges.add(SS3Singleton.getAudioTimeRange());
        var list = new JList<>(ranges.toArray(TimeRange[]::new));
        var gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridwidth = 1;
        panel.add(list, gbc);

        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        panel.add(Box.createHorizontalStrut(10));

        var info = new JPanel(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridwidth = 3;
        panel.add(info, gbc);

        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        info.add(Box.createHorizontalStrut(10), gbc);

       var lgbc = new GridBagConstraints();
        var tgbc = new GridBagConstraints();
        lgbc.gridx = 0;
        tgbc.gridx = 2;
        tgbc.gridwidth = 4;

        lgbc.gridy = 0;
        tgbc.gridy = 0;
        var name = new JTextField();
        name.setPreferredSize(new Dimension(120, 17));
        name.setEnabled(false);
        info.add(new JLabel("Name"), lgbc);
        info.add(name, tgbc);

        lgbc.gridy = 1;
        tgbc.gridy = 1;
        var parent = new JTextField();
        parent.setPreferredSize(new Dimension(120, 17));
        parent.setEnabled(false);
        info.add(new JLabel("Parent"), lgbc);
        info.add(parent, tgbc);

        lgbc.gridy = 2;
        tgbc.gridy = 2;
        var unit = new JTextField();
        unit.setPreferredSize(new Dimension(120, 17));
        unit.setEnabled(false);
        info.add(new JLabel("Unit"), lgbc);
        info.add(unit, tgbc);

        lgbc.gridy = 3;
        tgbc.gridy = 3;
        var offset = new JTextField();
        offset.setPreferredSize(new Dimension(120, 17));
        offset.setEnabled(false);
        info.add(new JLabel("Offset"), lgbc);
        info.add(offset, tgbc);


        list.addListSelectionListener(e -> {
            var range = list.getSelectedValue();
            if (range == null) {
                name.setText("");
                parent.setText("");
                unit.setText("");
                offset.setText("");
            } else {
                name.setText(range.name());
                parent.setText(range.parent().name());
                unit.setText(range.unit().toString());
                offset.setText(range.offset().toString());
            }
        });


        add(panel);
//        setPreferredSize(new Dimension(200, 350));
    }
}
