package edu.bu.signstream.ui.frame.dialog;

import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.ui.SS3SignStreamApplication;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class SaveDialog extends Dialog {
    public SaveDialog(Runnable onRun, Runnable onCancel) {
        var app = SS3Singleton.getSignStreamApplication();

        var panel = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));

        var dontSave = new JButton("Don't Save");
        dontSave.addActionListener(l -> {
            setVisible(false);
            onRun.run();
            SS3Singleton.setSavingFlag(false);
    		SS3Singleton.nullifySaveDialog();
        });
        panel.add(dontSave);

        var cancel = new JButton("Cancel");
        cancel.addActionListener(l -> {
            setVisible(false);
            onCancel.run();
            SS3Singleton.setSavingFlag(false);
    		SS3Singleton.nullifySaveDialog();
        });
        panel.add(cancel);

        var save = new JButton("Save");
        save.addActionListener(l -> {
            setVisible(false);
            app.saveCollection(SS3SignStreamApplication.SAVE);
            onRun.run();
            SS3Singleton.setSavingFlag(false);
    		SS3Singleton.nullifySaveDialog();
        });
        panel.add(save);

        var label = new JPanel();
        label.add(new JLabel("Save changes before proceeding?"));

        add(label);
        add(panel);
        
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                setVisible(false);
                onCancel.run();
                SS3Singleton.setSavingFlag(false);
        		SS3Singleton.nullifySaveDialog();
            }
        });

        SwingUtilities.invokeLater(save::requestFocus);
    }
}
