package edu.bu.signstream.ui.panels;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;

import edu.bu.signstream.ui.ButtonPanel;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class RenameDatabaseDialog extends JDialog implements ActionListener {

   private final int CANCEL = 4;
   private final int OK = 5;

   private boolean changedBoolean = false;
   private GenaricOneTxtFldPanel panel;
   private SS3SignStreamApplication application;
   private String nodeName = null;
   private TreePath treePath = null;
   
   private JButton btnCancel = new JButton(" Cancel ");
   private JButton btnOk = new JButton(" OK ");

   GridBagLayout gbl = new GridBagLayout();
   GridBagConstraints gbc = new GridBagConstraints();

   public RenameDatabaseDialog(SS3SignStreamApplication application, String nodeName) {
      super(application, " Rename Utterance ", true);
      this.application = application;
      this.nodeName = nodeName;

      panel = new GenaricOneTxtFldPanel(" Rename ");
      panel.setLabel(nodeName);

      addWindowListener(new WindowAdapter() {
         @Override
		public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      Container contentPane = getContentPane();
      contentPane.setLayout(new BorderLayout(50, 50));
      contentPane.add(createPanel(), BorderLayout.CENTER);
      this.pack();
   }

   public JPanel createPanel() {

      btnCancel.setToolTipText("Check this to cancel.");
      btnCancel.setActionCommand("" + CANCEL);

      btnOk.setToolTipText("Check this to add new field.");
      btnOk.setActionCommand("" + OK);

      btnCancel.addActionListener(this);
      btnOk.addActionListener(this);

      Dimension dim = new Dimension(80, 21);
      btnCancel.setPreferredSize(dim);
      btnOk.setPreferredSize(dim);

      ButtonPanel btnPanel = new ButtonPanel();
      btnPanel.add(btnCancel);
      btnPanel.add(btnOk);

      int width = (int) (panel.getPreferredSize().getWidth() + 30);
      int height = (int) panel.getPreferredSize().getHeight() + 20;

      panel.setPreferredSize(new Dimension(width, height));

      JPanel cpanel = new JPanel();
      cpanel.setLayout(new BorderLayout());
      cpanel.add(panel, BorderLayout.CENTER);
      cpanel.add(btnPanel, BorderLayout.SOUTH);

      return cpanel;
   }

   @Override
public void actionPerformed(ActionEvent ae) {
      String str = ae.getActionCommand();

      switch (Integer.parseInt(str)) {
         case CANCEL :
            this.dispose();
            break;
         case OK :
            String label = panel.getLabel();
            if (!label.equals(nodeName)) {
               nodeName = label;
               
               JTree tree = application.getSignStreamSegmentPanel().getDbNavigationPanel().getJTree();
               //TreePath path = tree.getSelectionPath();
               TreeNode treeNode = (TreeNode)tree.getModel().getRoot();
               
               DefaultTreeModel model = (DefaultTreeModel)tree.getModel();
               //tree.makeVisible(path);
               model.reload(treeNode);
               
               //tree.makeVisible(path);
               //tree.setSelectionPath(path);
               
               application.repaint();
            }

            this.dispose();
            break;
      }
   }
}
