package edu.bu.signstream.ui.panels.codingScheme;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.JDialog;

import edu.bu.signstream.grepresentation.fields.Segment;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.NonmanualFieldsView;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GraphFieldDialog extends JDialog {
	
	private static final long serialVersionUID = 1L;

	private GraphFieldPanel graphFieldPanel = null;

	public GraphFieldDialog(SignStreamSegmentPanel segmentPanel, Segment segment, NonmanualFieldsView nonManualView,
			PresentationField parentField) {

		super(SS3Singleton.getSignStreamApplication(), true); // sets modal to true
		setTitle("Graph Selector");

		graphFieldPanel = new GraphFieldPanel(segmentPanel, segment, nonManualView, this, parentField);
		graphFieldPanel.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());
		contentPane.add(graphFieldPanel, BorderLayout.CENTER);

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent we) {
				graphFieldPanel.discard();
				removeWindowListener(this);
				dispose();
			}
		});

		setSize(getPreferredSize().width + 15, getPreferredSize().height + 50);
		setLocation(150, 150);
		pack();
	}

	public GraphFieldPanel getGraphFieldPanel() {
		return graphFieldPanel;
	}

	public void setSelectedField(String fieldID, boolean selected) {
		graphFieldPanel.setSelectedField(fieldID, selected);
	}

	public void enter() {
		graphFieldPanel.enter();
	}

	public Segment getSegment() {
		return graphFieldPanel.getSegment();
	}

	public void setVisible(boolean b, String fieldID) {
		graphFieldPanel.scrollToAndSelectFieldByID(fieldID);

		super.setVisible(b);
	}
}
