package edu.bu.signstream.ui.panels.codingScheme;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;

import javax.swing.JPanel;

public class ValueAlignmentPanel extends JPanel {
   public static int ALGMNT_RIGHT = 0;
   public static int ALGMNT_LEFT = 1;
   public static int ALGMNT_CENTER = 2;
   public static int ALGMNT_RIGHT_N_LEFT = 3;

   private int alignment = 0;

   public ValueAlignmentPanel(int alignment) {
      this.alignment = alignment;
   }

   @Override
public void paint(Graphics g) {
      int fontSize = 12, fontStyle = Font.PLAIN;
      String fontFamily = "Times-Roman";
      Font font = new Font(fontFamily, fontStyle, fontSize);
      Color bkgrdColor = new Color(255, 247, 200);
      Graphics2D g2d = (Graphics2D) g;
      
      g2d.setColor(bkgrdColor);
      g2d.fillRect(0, 0, getWidth(), getHeight());
      
      g.setColor(Color.GRAY);
      g2d.draw(new Line2D.Double(0, 0, 0, getHeight()));
      g2d.draw(new Line2D.Double(getWidth(), 0, getWidth(), getHeight()));
      g2d.draw(new Line2D.Double(0, 0, 0, getHeight()));
      g2d.draw(new Line2D.Double(0, 0, getWidth(), 0));
      g2d.draw(new Line2D.Double(0, getHeight(), getWidth(), getHeight()));

      g.setFont(font);
      g.setColor(Color.DARK_GRAY);

      int X1 = 13;
      int X2 = getWidth() - 13;
      int Y = 14;

      g2d.draw(new Line2D.Double(X1, Y, X2, Y));
      g2d.draw(new Line2D.Double(X1, Y + 1, X2, Y + 1));
      g2d.draw(new Line2D.Double(X1, Y - 2, X1, Y + 3));
      g2d.draw(new Line2D.Double(X2, Y - 2, X2, Y + 3));
      
      String label1 = "V1";
      String label2 = "V2";
      
      FontMetrics fontMetrics = getFontMetrics(font);    
      int v1 = fontMetrics.stringWidth(label1);
      int v2 = fontMetrics.stringWidth(label2);
     
     if(alignment == ALGMNT_RIGHT) {
        g2d.drawString("V1", X2-v2/2, Y-1);
     } else if(alignment == ALGMNT_LEFT) {
        g2d.drawString("V1", X1-v1/2, Y-1);
     } else if(alignment == ALGMNT_CENTER) {
        g2d.drawString("V1", (X2-X1+v1)/2, Y-1);
     } else if(alignment == ALGMNT_RIGHT_N_LEFT) {
        g2d.drawString("V1", X1-v1/2, Y-1);
        g2d.drawString("V2", X2-v2/2, Y-1);
     }
   }
}
