package edu.bu.signstream.ui.panels.colorChooser;

import java.awt.Component;
import java.awt.Dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JColorChooser;
import javax.swing.JLabel;


class ColorComboBoxEditor extends AbstractComboBoxEditor {
	ColorIcon editorIcon = new ColorIcon();
	JLabel editorLabel = new JLabel(editorIcon);

	Item item;

	JColorChooser colorChooser = new JColorChooser();
	ActionListener okListener = new OKListener();
		Dialog dialog = JColorChooser.createDialog(null, // parentComponent
		"Choose A Color", // title
		true, // modal
	colorChooser, okListener, null); // cancel listener


	public ColorComboBoxEditor() {
		editorLabel.setBorder(BorderFactory.createEtchedBorder());

		editorLabel.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				dialog.setVisible(true);
			}
		});
	}
	class OKListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			item = new Item(new Object[] { colorChooser.getColor(), null });

			fireActionPerformed(e);
		}
	}
	@Override
	public Component getEditorComponent() {
		return editorLabel;
	}
	@Override
	public Object getItem() {
		return item;
	}
	@Override
	public void setItem(Object itemToSet) {
		item = (Item) itemToSet;

		// cannot set the selected item in an editor's
		// setItem method, or an infinite loop results

		editorIcon.setColor(item.getColor());
		editorLabel.setText(item.toString());
	}
	@Override
	public void selectAll() {
		// from ComboBoxModel interface:  nothing to select	
	}
}