package edu.bu.signstream.ui.panels.newDatabase;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

import edu.bu.signstream.common.util.signbank.SignBankResourceCollection;
import edu.bu.signstream.common.util.vo.Excerpt;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Database;
import edu.bu.signstream.common.util.vo.ss3.media.SS3MediaLibrary;
import edu.bu.signstream.common.util.vo.ss3.participants.ParticipantsLibrary;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.media.fileNavigation.LoadedMediaFile;

public class CreateUpdateMacroUnitDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	CreateUpdateMacroUnit mUnitPanel = null;

	public CreateUpdateMacroUnitDialog(int function, SS3Database db, Excerpt excerptToUpdate, 
			ArrayList<LoadedMediaFile> mFiles,
            ArrayList<LoadedMediaFile> mAudioFiles,
			SS3MediaLibrary mLibrary,
			ParticipantsLibrary participantsLibrary,
			ParticipantsLibrary annotatorsLibrary,
			SignBankResourceCollection resourceCollection,
			SignStreamSegmentPanel segmentPanel, JFrame parentFrame) {
		super(parentFrame);
		super.setTitle("Macro Unit Information");
		super.setLocationRelativeTo(segmentPanel);

		mUnitPanel = new CreateUpdateMacroUnit(function, db, excerptToUpdate, mFiles, mAudioFiles, mLibrary, participantsLibrary, annotatorsLibrary,
				resourceCollection, segmentPanel, this, parentFrame);
		
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);		// without this, the below windowClosing will always close after executing

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				mUnitPanel.cancelEntry();
			}
		});

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(70, 70));
		contentPane.add(mUnitPanel, BorderLayout.CENTER);

		this.pack();
	}

    @Override
    public void dispose() {
        super.dispose();
        SS3Singleton.getSignStreamApplication().unblock();
    }

    @Override
    public void setVisible(boolean b) {
	    if (b) {
            SS3Singleton.getSignStreamApplication().block();
            requestFocus();
        } else {
            SS3Singleton.getSignStreamApplication().unblock();
        }
        super.setVisible(b);
    }

    public void update(
			int function, SS3Database db,
			Excerpt excerptToUpdate, ArrayList<LoadedMediaFile> mFiles, ArrayList<LoadedMediaFile> mAudioFiles,
			SS3MediaLibrary mLibrary, ParticipantsLibrary participantsLibrary,
			ParticipantsLibrary annotatorsLibrary,
			SignBankResourceCollection resourceCollection) {
		
		mUnitPanel.update(function, db,
				mFiles, mAudioFiles,
				mLibrary, participantsLibrary,
				annotatorsLibrary,
				resourceCollection);
	}
	
	public CreateUpdateMacroUnit getMacroUnitPanel() {
		return mUnitPanel;
	}
}
